
cat ("My pid:", Sys.getpid (), "\n\n")

AnzSubj <- 28
AnzTreat <- 10

AnzDat <- rep (AnzSubj, AnzTreat)
FullData <- read.table (file="altruism.csv", header=T, sep=",")
dat <- data.frame(id=FullData$id, tr=FullData$decision, cond=FullData$treat, resp=FullData$peasant, d=FullData$dec, endow=FullData$endow, self=FullData$self, other=FullData$other)


Low <-  rep(0, AnzTreat)
Step <- dat$self[1:AnzTreat] / 10
Rate <- dat$other[1:AnzTreat] / dat$self[1:AnzTreat]
Up <- dat$endow[1:AnzTreat] * Step
DictEndow <- Up
RecEndow <- rep(0, AnzTreat)


dat1 <- dat[dat$cond=="o" & dat$resp==0,]
SubjV1 <- levels(as.factor( (dat1$id)))
AnzSubj1 <- length(SubjV1)
data1 <- array (0, c(AnzSubj1, AnzTreat))

for (i in 1:AnzSubj1) {
    s <- SubjV1[i]
    d <- dat1$endow[dat1$id==s] - dat1$d[dat1$id==s]
    data1[i,] <- as.double (d)
}

dat2 <- dat[dat$cond=="oc" & dat$resp==0,]
SubjV2 <- levels(as.factor( (dat2$id)))
AnzSubj2 <- length(SubjV2)
data2 <- array (0, c(AnzSubj2, AnzTreat))

for (i in 1:AnzSubj2) {
    s <- SubjV2[i]
    d <- dat2$endow[dat2$id==s] - dat2$d[dat2$id==s]
    data2[i,] <- as.double (d)
}

data <- rbind(data1,data2)
AnzSubj <- dim(data)[1]

TRatio <- c("2:4", "2:6", "2:2", "2:4", "5:5", "1:2", "2:3", "2:4", "2:5", "2:8")

#####################################################################


for (t in 1:10) {
  filename <- paste("hist-harr2-", t, ".pdf", sep="")
  pdf (filename, width=9, height=6)
  par(mar=c(5,4.5,4,2) + 0.1)
  
  s <- (Up[t]/Step[t] - data[,t]) / (Up[t]/Step[t])
  cat ("Treatment", t, ": Num =", length(s), "\tMean =", mean(s), "\tMean|s>0 =", mean(s[s>0]), "\tSD =", sd(s), "\n")
  
  hist(s,
       xlim=c(0,1), #ylim=c(0,25),
       breaks=0:100/100,
       main="",
#       main=list(paste("Treatment ", t, "  (B=", Up[t]/Step[t],", Tau1=", Step[t], ", ", expression(tau[2]), "=", Step[t]*Rate[t], ")", sep=""), cex=1.5),
       xlab=list("Budget share transfered", cex=1.8),
       ylab=list("Percentage of choices", cex=1.8),
       freq=FALSE,
       cex.axis=1.8)
  dev.off()
}



ratioV <- c(4/2, 6/2, 2/2, 4/2, 5/5, 1/1, 3/2, 4/2, 5/2, 8/2)

sortRatioV <- c()
meanV <- c()
sdV <- c()
mean2V <- c()

for (n in 1:6) {
    if (n==1) tV <- c(3,5,6)
    if (n==2) tV <- c(7)
    if (n==3) tV <- c(1,4,8)
    if (n==4) tV <- c(9)
    if (n==5) tV <- c(2)
    if (n==6) tV <- c(10)

    s <- c()
    for (t in tV) s <- c(s, (Up[t]/Step[t] - data[,t]) / (Up[t]/Step[t]))

    sortRatioV <- c(sortRatioV, ratioV[tV[1]])
    meanV <- c(meanV, mean(s))
    mean2V <- c(mean2V, mean(s[s>0]))
    sdV <- c(sdV, sd(s))
}

cat ("ratioHarr <- c(", paste(sortRatioV, collapse=","), ")\n")
cat ("meanHarr <- c(", paste(meanV, collapse=","), ")\n")
