
  cat ("Extern, AnzTypes =", AnzTypes, " (", fnameP2, ") -- op =", round (res$estimate, digits=3), "\n")
  origFnameP1 <- fnameP1
  origFnameP2 <- fnameP2
  origBaseParMin <- baseParMin
  origBaseParMax <- baseParMax

  adeq$PB1 <- 0 ; adeq$PB1Ind <- 0   # External consistency of preference estimates from all other data sets
  adeq$PB2 <- 0 ; adeq$PB2Ind <- 0   # External consistency of preference,precision estimates from all other data sets
  adeq$PB3 <- 0 ; adeq$PB3Ind <- 0   # Full external consistency of preference,precision,choice estimates from all other data sets

  adeq$PB1Mom <- 0
  adeq$PB2Mom <- 0

  adeq$PB1a <- 0 ; adeq$PB1aInd <- 0; adeq$PB1aMom <- 0 # External consistency from other "large" data sets (Garp Harr Fis)
  adeq$PB2a <- 0 ; adeq$PB2aInd <- 0; adeq$PB2aMom <- 0
  adeq$PB3a <- 0 ; adeq$PB3aInd <- 0; adeq$PB3aMom <- 0

  adeq$PB1b <- 0 ; adeq$PB1bInd <- 0; adeq$PB1bMom <- 0  # External consistency from other "small" data sets (Capp Bard Fis)
  adeq$PB2b <- 0 ; adeq$PB2bInd <- 0
  adeq$PB3b <- 0 ; adeq$PB3bInd <- 0

  adeq$PB3c <- 0 ; adeq$PB3cInd <- 0; adeq$PB3cMom <- 0  # Full external consistency from other large, numerically entered data sets (Garp, Harr)
  adeq$PB3d <- 0 ; adeq$PB3dInd <- 0

  adeq$PB1e <- 0 ; adeq$PB1eInd <- 0 ; adeq$PB1eMom <- 0  # External consistency from other dictator games
  adeq$PB1f <- 0 ; adeq$PB1fInd <- 0 ; adeq$PB1fMom <- 0  # External consistency from other taking games
  adeq$PB2e <- 0 ; adeq$PB2eInd <- 0
  adeq$PB2f <- 0 ; adeq$PB2fInd <- 0
  adeq$PB3e <- 0 ; adeq$PB3eInd <- 0
  adeq$PB3f <- 0 ; adeq$PB3fInd <- 0


  adeq$PF1 <- 0 ; adeq$PF1Ind <- c() ; adeq$PF1Mom <- array(0, c(0,8))   # Prediction from current exp to other experiments
  adeq$PF2 <- 0 ; adeq$PF2Ind <- c()
  adeq$PF3 <- 0 ; adeq$PF3Ind <- c()
  
  adeq$PF1a <- 0 ; adeq$PF1aInd <- c() ; adeq$PF1aMom <- array(0, c(0,8)) # Prediction from current to rich dictator games
  adeq$PF2a <- 0 ; adeq$PF2aInd <- c()
  adeq$PF3a <- 0 ; adeq$PF3aInd <- c()
  
  adeq$PF1e <- 0 ; adeq$PF1eInd <- c() ; adeq$PF1eMom <- array(0, c(0,8))  # Prediction from current to other dictator games
  adeq$PF1f <- 0 ; adeq$PF1fInd <- c() ; adeq$PF1fMom <- array(0, c(0,8))  # Prediction from current to other taking games
  adeq$PF2e <- 0 ; adeq$PF2eInd <- c()
  adeq$PF2f <- 0 ; adeq$PF2fInd <- c()
  adeq$PF3e <- 0 ; adeq$PF3eInd <- c()
  adeq$PF3f <- 0 ; adeq$PF3fInd <- c()
  
  adeq$PB1g <- 0 ; adeq$PB1gInd <- 0 ; adeq$PB1gMom <- 0  # Prediction from current to "numerical games"
  adeq$PB2g <- 0 ; adeq$PB2gInd <- 0
  adeq$PB3g <- 0 ; adeq$PB3gInd <- 0
  adeq$PF1g <- 0 ; adeq$PF1gInd <- c() ; adeq$PF1gMom <- array(0, c(0,8))
  adeq$PF2g <- 0 ; adeq$PF2gInd <- c()
  adeq$PF3g <- 0 ; adeq$PF3gInd <- c()

  adeq$PredOthAbs <- array (0, c(3,6))
  adeq$PredOthRel <- array (0, c(3,6))
  adeq$PredThisAbs <- array (0, c(3,6))
  adeq$PredThisRel <- array (0, c(3,6))

  ct <- cta <- ctb <- ctc <- ctd <- cte <- ctf <- ctg <- 0

  expCt <- 0
  for (dirName in c("capp", "garp", "harr", "fis", "bard", "list")) {
      expCt <- expCt + 1

      if (dirName==origFnameP1) next
      rm(list=ls(pattern="prLevs"))

      #####################################################################
      # Use current res$estimate to predict other data
      
      othFName <- paste ("../", dirName, "-", fnameP2, sep="")
      if (file.exists(othFName)) {
          source (othFName)
          baseParMin <- origBaseParMin
          baseParMax <- origBaseParMax
      
          ll <- GetLL (res$estimate, RelTr=InTreats0) ; cl <- calcCLC (ll)
          
      } else { ll <- 0 ; cl <- 0  }
      
      printToFile (TexFileExt, ll, 0, delAnzTypes=0)
      printToFile (TexFileExt, cl, 0, "1", delAnzTypes=0)
      
      cat (origFnameP1, "=>", dirName, " (full):  ll =", ll, "\tclc =", cl, "\n")
      

      #####################################################################
      # Use preference parameters from current res$estimate to predict other data
      
      ResFile2 <- paste ("RData/", baseName, ".Rdata", ".res", AnzTypes, sep="")
      othResFile <- paste ("../", dirName, "-", strsplit (fnameP2, split="/")[[1]][1], "/", ResFile2, sep="")
      if (file.exists(othFName) && file.exists(othResFile)) {
          origRes <- res
          
          load(othResFile)
          
          if (1) {
              llextr2 <- calcLLmax (RelTr=InTreats0)
              llextr2Ind <- lastIndivLL
              fac <- 1
          } else {
              llextr2 <- calcLLmin (RelTr=InTreats0)
              llextr2Ind <- lastIndivLL
              fac <- -1
          }
                    
          # Preference only
          othRes <- res2 <- res$estimate
          for (t in 1:AnzTypes) {
              res2[(t-1)*(AnzTypePars+1)+4:5+1] <- origRes$estimate[(t-1)*(AnzTypePars+1)+4:5+1]
              if (AnzTypePars>5) res2[(t-1)*(AnzTypePars+1)+6:7+1] <- origRes$estimate[(t-1)*(AnzTypePars+1)+6:7+1]
          }
          
          ll2 <- GetLL (res2, RelTr=InTreats0) ; cl2 <- calcCLC (ll2) ; prefPars <- res2
          adeq$PredOthAbs[1,expCt] <- ll2Abs <- ll2
          adeq$PredOthRel[1,expCt] <- ll2Rel <- abs(ll2) - abs(llextr2)
          
          bicPen1 <- (length(res$estimate)-1-4) * log(AnzObs) /2
          ll2 <- abs(ll2) + bicPen1
          lastIndivLL <- lastIndivLL - rep (bicPen1/AnzSubj, AnzSubj)

          adeq$PF1 <- adeq$PF1 + fac * (abs(ll2) - abs(llextr2))
          adeq$PF1Ind <- c(adeq$PF1Ind, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
          adeq$PF1Mom <- rbind (adeq$PF1Mom, setLastMoms (NULL, RelTr=InTreats0))

          if (dirName %in% c("garp", "harr", "fis")) {
              adeq$PF1a <- adeq$PF1a + fac * (abs(ll2)  - abs(llextr2))
              adeq$PF1aInd <- c(adeq$PF1aInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
              adeq$PF1aMom <- rbind (adeq$PF1aMom, setLastMoms (NULL, RelTr=InTreats0))
          }
          
          if (dirName %in% c("garp", "harr", "fis", "capp")) {
              adeq$PF1e <- adeq$PF1e + fac * (abs(ll2)  - abs(llextr2))
              adeq$PF1eInd <- c(adeq$PF1eInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
              adeq$PF1eMom <- rbind (adeq$PF1eMom, setLastMoms (NULL, RelTr=InTreats0))

          } else {
              adeq$PF1f <- adeq$PF1f + fac * (abs(ll2) - abs(llextr2))
              adeq$PF1fInd <- c(adeq$PF1fInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
              adeq$PF1fMom <- rbind (adeq$PF1fMom, setLastMoms (NULL, RelTr=InTreats0))
          }

          if (dirName %in% c("garp", "harr", "capp")) {
              adeq$PF1g <- adeq$PF1g + fac * (abs(ll2)  - abs(llextr2))
              adeq$PF1gInd <- c(adeq$PF1gInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
              adeq$PF1gMom <- rbind (adeq$PF1gMom, setLastMoms (NULL, RelTr=InTreats0))
          }
          
          
          # Preference and precision 
          res2 <- othRes
          for (t in 1:AnzTypes) {
              res2[(t-1)*(AnzTypePars+1)+c(1,4:5)+1] <- origRes$estimate[(t-1)*(AnzTypePars+1)+c(1,4:5)+1]
              if (AnzTypePars>5) res2[(t-1)*(AnzTypePars+1)+6:7+1] <- origRes$estimate[(t-1)*(AnzTypePars+1)+6:7+1]
              if (AnzTypePars>7) res2[(t-1)*(AnzTypePars+1)+8+1] <- origRes$estimate[(t-1)*(AnzTypePars+1)+8+1]
          }

          ll2x <- GetLL (res2, RelTr=InTreats0) ; cl2x <- calcCLC (ll2)
          adeq$PredOthAbs[2,expCt] <- ll2x
          adeq$PredOthRel[2,expCt] <- abs(ll2x) - abs(llextr2)
          
          bicPen2 <- (length(res$estimate)-1-6) * log(AnzObs) /2
          ll2x <- abs(ll2x) + bicPen2
          lastIndivLL <- lastIndivLL - rep (bicPen2/AnzSubj, AnzSubj)
          
          adeq$PF2 <- adeq$PF2 + fac * (abs(ll2x) - abs(llextr2))
          adeq$PF2Ind <- c(adeq$PF2Ind, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
          
          if (dirName %in% c("garp", "harr", "fis")) {
              adeq$PF2a <- adeq$PF2a + fac * (abs(ll2x)  - abs(llextr2))
              adeq$PF2aInd <- c(adeq$PF2aInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
          }
          
          if (dirName %in% c("garp", "harr", "fis", "capp")) {
              adeq$PF2e <- adeq$PF2e + fac * (abs(ll2x)  - abs(llextr2))
              adeq$PF2eInd <- c(adeq$PF2eInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
          } else {
              adeq$PF2f <- adeq$PF2f + fac * (abs(ll2x) - abs(llextr2))
              adeq$PF2fInd <- c(adeq$PF2fInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
          }

          if (dirName  %in% c("garp", "harr", "capp")) {
              adeq$PF2g <- adeq$PF2g + fac * (abs(ll2x)  - abs(llextr2))
              adeq$PF2gInd <- c(adeq$PF2gInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
          }
          
          
          # All parameters
          ll2x <- GetLL (origRes$estimate, RelTr=InTreats0)
          adeq$PredOthAbs[3,expCt] <- ll2x
          adeq$PredOthRel[3,expCt] <- abs(ll2x) - abs(llextr2)
          
          adeq$PF3 <- adeq$PF3 + fac * (abs(ll2x) - abs(llextr2))
          adeq$PF3Ind <- c(adeq$PF3Ind, fac * (abs(lastIndivLL) - abs(llextr2Ind)))

          if (dirName %in% c("garp", "harr", "fis")) {
              adeq$PF3a <- adeq$PF3a + fac * (abs(ll2x) - abs(llextr2))
              adeq$PF3aInd <- c(adeq$PF3aInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
          }
          
          if (dirName %in% c("garp", "harr", "fis", "capp")) {
              adeq$PF3e <- adeq$PF3e + fac * (abs(ll2x) - abs(llextr2))
              adeq$PF3eInd <- c(adeq$PF3eInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
          } else {
              adeq$PF3f <- adeq$PF3f + fac * (abs(ll2x) - abs(llextr2))
              adeq$PF3fInd <- c(adeq$PF3fInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
          }
          
          if (dirName  %in% c("garp", "harr", "capp")) {
              adeq$PF3g <- adeq$PF3g + fac * (abs(ll2x) - abs(llextr2))
              adeq$PF3gInd <- c(adeq$PF3gInd, fac * (abs(lastIndivLL) - abs(llextr2Ind)))
          }

          res <- origRes
          
      } else { ll2 <- 0 ; cl2 <- 0  }
      
      printToFile (TexFileExt, ll2, 0, "2", delAnzTypes=0)
      printToFile (TexFileExt, cl2, 0, "3", delAnzTypes=0)

      cat (origFnameP1, "=>", dirName, " (pref): \tll-abs =", ll2Abs, "\tll-rel =", ll2Rel, "\t(p=", round(prefPars, digits=3), ")\n")


      #####################################################################
      # Use other res$estimate to predict current data

      fname <- paste ("../", origFnameP1, "-", origFnameP2, sep="")
      source (fname)
      rm(list=ls(pattern="prLevs"))

      if (file.exists(othFName) && file.exists(othResFile)) {
          
          if (1) {
              llextr2 <- calcLLmax (RelTr=InTreats0)
              llextr2Ind <- lastIndivLL
              fac <- 1
          } else {
              llextr2 <- calcLLmin (RelTr=InTreats0)
              llextr2Ind <- lastIndivLL
              fac <- -1
          }

          # Preference only
          res2 <- res$estimate
          for (t in 1:AnzTypes) {
              res2[(t-1)*(AnzTypePars+1)+4:5+1] <- othRes[(t-1)*(AnzTypePars+1)+4:5+1]
              if (AnzTypePars>5) res2[(t-1)*(AnzTypePars+1)+6:7+1] <- othRes[(t-1)*(AnzTypePars+1)+6:7+1]
          }

          llx <- GetLL (res2, RelTr=InTreats0) ; prefPars <- res2
          adeq$PredThisAbs[1,expCt] <- ll2Abs <- llx
          adeq$PredThisRel[1,expCt] <- ll2Rel <- abs(llx) - abs(llextr2)
          
          bicPen1 <- (length(res$estimate)-1-4) * log(AnzObs) /2
          llx <- abs(llx) + bicPen1
          lastIndivLL <- lastIndivLL - rep (bicPen1/AnzSubj, AnzSubj)
          
          llx <- fac * (abs(llx) - abs(llextr2)) ; lli <- fac * (abs(lastIndivLL) - abs(llextr2Ind))
          adeq$PB1 <- adeq$PB1 + llx ; adeq$PB1Ind <- adeq$PB1Ind + lli
          adeq$PB1Mom <- adeq$PB1Mom + setLastMoms (NULL, RelTr=InTreats0)
          
          if (dirName %in% c("garp", "harr", "fis")) {
              adeq$PB1a <- adeq$PB1a + llx ; adeq$PB1aInd <- adeq$PB1aInd + lli
              adeq$PB1aMom <- adeq$PB1aMom + setLastMoms (NULL, RelTr=InTreats0)
          } else {
              adeq$PB1b <- adeq$PB1b + llx ; adeq$PB1bInd <- adeq$PB1bInd + lli
              adeq$PB1bMom <- adeq$PB1bMom + setLastMoms (NULL, RelTr=InTreats0)
          }

          if (dirName %in% c("garp", "harr", "fis", "capp")) {
              adeq$PB1e <- adeq$PB1e + llx ; adeq$PB1eInd <- adeq$PB1eInd + lli
              adeq$PB1eMom <- adeq$PB1eMom + setLastMoms (NULL, RelTr=InTreats0)
          } else {
              adeq$PB1f <- adeq$PB1f + llx ; adeq$PB1fInd <- adeq$PB1fInd + lli
              adeq$PB1fMom <- adeq$PB1fMom + setLastMoms (NULL, RelTr=InTreats0)
          }

          if (dirName  %in% c("garp", "harr", "capp")) {
              adeq$PB1g <- adeq$PB1g + llx ; adeq$PB1gInd <- adeq$PB1gInd + lli
              adeq$PB1gMom <- adeq$PB1gMom + setLastMoms (NULL, RelTr=InTreats0)
          }

          makeFitPlot ("out-pref", origFnameP1, dirName)

          
          # Preference and precision
          res2 <- res$estimate
          for (t in 1:AnzTypes) {
              res2[(t-1)*(AnzTypePars+1)+c(1,4:5)+1] <- othRes[(t-1)*(AnzTypePars+1)+c(1,4:5)+1]
              if (AnzTypePars>5) res2[(t-1)*(AnzTypePars+1)+6:7+1] <- othRes[(t-1)*(AnzTypePars+1)+6:7+1]
              if (AnzTypePars>7) res2[(t-1)*(AnzTypePars+1)+8+1] <- othRes[(t-1)*(AnzTypePars+1)+8+1]
          }

          llx <- GetLL (res2, RelTr=InTreats0)
          adeq$PredThisAbs[2,expCt] <- llx
          adeq$PredThisRel[2,expCt] <- abs(llx) - abs(llextr2)
          
          bicPen2 <- (length(res$estimate)-1-6) * log(AnzObs) /2
          llx <- abs(llx) + bicPen2
          lastIndivLL <- lastIndivLL - rep (bicPen2/AnzSubj, AnzSubj)
          
          llx <- fac * (abs(llx) - abs(llextr2)) ; lli <- fac * (abs(lastIndivLL) - abs(llextr2Ind))
          adeq$PB2 <- adeq$PB2 + llx ; adeq$PB2Ind <- adeq$PB2Ind + lli
          adeq$PB2Mom <- adeq$PB2Mom + setLastMoms (NULL, RelTr=InTreats0)
          
          if (dirName %in% c("garp", "harr", "fis")) {
              adeq$PB2a <- adeq$PB2a + llx ; adeq$PB2aInd <- adeq$PB2aInd + lli
              adeq$PB2aMom <- adeq$PB2aMom + setLastMoms (NULL, RelTr=InTreats0)
          } else {
              adeq$PB2b <- adeq$PB2b + llx ; adeq$PB2bInd <- adeq$PB2bInd + lli
          }

          if (dirName %in% c("garp", "harr", "fis", "capp")) { adeq$PB2e <- adeq$PB2e + llx ; adeq$PB2eInd <- adeq$PB2eInd + lli  }
          else { adeq$PB2f <- adeq$PB2f + llx ; adeq$PB2fInd <- adeq$PB2fInd + lli  }
          
          if (dirName %in% c("garp", "harr", "capp")) { adeq$PB2g <- adeq$PB2g + llx ; adeq$PB2gInd <- adeq$PB2gInd + lli }

          # All parameters
          llx <- GetLL (othRes, RelTr=InTreats0)
          adeq$PredThisAbs[3,expCt] <- llx
          adeq$PredThisRel[3,expCt] <- abs(llx) - abs(llextr2)
          
          llx <- fac * (abs(llx) - abs(llextr2)) ; lli <- fac * (abs(lastIndivLL) - abs(llextr2Ind))
          adeq$PB3 <- adeq$PB3 + llx ; adeq$PB3Ind <- adeq$PB3Ind + lli ; ct <- ct+1
          if (dirName %in% c("garp", "harr", "fis")) {
              adeq$PB3a <- adeq$PB3a + llx ; adeq$PB3aInd <- adeq$PB3aInd + lli ; cta <- cta+1
              adeq$PB3aMom <- adeq$PB3aMom + setLastMoms (NULL, RelTr=InTreats0)
          } else {
              adeq$PB3b <- adeq$PB3b + llx ; adeq$PB3bInd <- adeq$PB3bInd + lli ; ctb <- ctb+1
          }

          if (dirName %in% c("garp", "harr")) {
              adeq$PB3c <- adeq$PB3c + llx ; adeq$PB3cInd <- adeq$PB3cInd + lli ; ctc <- ctc+1
              adeq$PB3cMom <- adeq$PB3cMom + setLastMoms (NULL, RelTr=InTreats0)
          } else { adeq$PB3d <- adeq$PB3d + llx ; adeq$PB3dInd <- adeq$PB3dInd + lli ; ctd <- ctd+1 }
          
          if (dirName %in% c("garp", "harr", "fis", "capp")) { adeq$PB3e <- adeq$PB3e + llx ; adeq$PB3eInd <- adeq$PB3eInd + lli ; cte <- cte+1 }
          else { adeq$PB3f <- adeq$PB3f + llx ; adeq$PB3fInd <- adeq$PB3fInd + lli ; ctf <- ctf+1 }
          
          if (dirName %in% c("garp", "harr", "capp")) {
              adeq$PB3g <- adeq$PB3g + llx ; adeq$PB3gInd <- adeq$PB3gInd + lli; ctg <- ctg+1
          }
      }

      cat (dirName, "=>", origFnameP1, " (pref): \tll-abs =", ll2Abs, "\tll-rel =", ll2Rel, "\t(p=", round(prefPars, digits=3), ")\n")

  }

  if (1) {
      adeq$PB1Mom <- adeq$PB1Mom / pmax(ct, 1)
      adeq$PB1aMom <- adeq$PB1aMom / pmax(cta, 1)
      adeq$PB1bMom <- adeq$PB1bMom / pmax(ctb, 1)
      adeq$PB1eMom <- adeq$PB1eMom / pmax(cte, 1)
      adeq$PB1fMom <- adeq$PB1fMom / pmax(ctf, 1)
      adeq$PB1gMom <- adeq$PB1gMom / pmax(ctg, 1)
      
      adeq$PB2Mom <- adeq$PB2Mom / pmax(ct, 1)
      adeq$PB2aMom <- adeq$PB2aMom / pmax(cta, 1)
      adeq$PB3aMom <- adeq$PB3aMom / pmax(cta, 1)
      adeq$PB3cMom <- adeq$PB3cMom / pmax(ctc, 1)
  }

  if (0) { # Not done anymore, to maintain comparability to PFxx
      adeq$PB1 <- adeq$PB1 / pmax(ct, 1) ; adeq$PB1Ind <- adeq$PB1Ind / pmax(ct, 1)
      adeq$PB2 <- adeq$PB2 / pmax(ct, 1) ; adeq$PB2Ind <- adeq$PB2Ind / pmax(ct, 1)
      adeq$PB3 <- adeq$PB3 / pmax(ct, 1) ; adeq$PB3Ind <- adeq$PB3Ind / pmax(ct, 1)
      
      adeq$PB1a <- adeq$PB1a / pmax(cta, 1) ; adeq$PB1aInd <- adeq$PB1aInd / pmax(cta, 1)
      adeq$PB2a <- adeq$PB2a / pmax(cta, 1) ; adeq$PB2aInd <- adeq$PB2aInd / pmax(cta, 1)
      adeq$PB3a <- adeq$PB3a / pmax(cta, 1) ; adeq$PB3aInd <- adeq$PB3aInd / pmax(cta, 1)
      
      adeq$PB1b <- adeq$PB1b / pmax(ctb, 1) ; adeq$PB1bInd <- adeq$PB1bInd / pmax(ctb, 1)
      adeq$PB2b <- adeq$PB2b / pmax(ctb, 1) ; adeq$PB2bInd <- adeq$PB2bInd / pmax(ctb, 1)
      adeq$PB3b <- adeq$PB3b / pmax(ctb, 1) ; adeq$PB3bInd <- adeq$PB3bInd / pmax(ctb, 1)
      
      adeq$PB3c <- adeq$PB3c / pmax(ctc, 1) ; adeq$PB3cInd <- adeq$PB3cInd / pmax(ctc, 1)
      adeq$PB3d <- adeq$PB3d / pmax(ctd, 1) ; adeq$PB3dInd <- adeq$PB3dInd / pmax(ctd, 1)
      
      adeq$PB1e <- adeq$PB1e / pmax(cte, 1) ; adeq$PB1eInd <- adeq$PB1eInd / pmax(cte, 1)
      adeq$PB1f <- adeq$PB1f / pmax(ctf, 1) ; adeq$PB1fInd <- adeq$PB1fInd / pmax(ctf, 1)
      adeq$PB2e <- adeq$PB2e / pmax(cte, 1) ; adeq$PB2eInd <- adeq$PB2eInd / pmax(cte, 1)
      adeq$PB2f <- adeq$PB2f / pmax(ctf, 1) ; adeq$PB2fInd <- adeq$PB2fInd / pmax(ctf, 1)
      adeq$PB3e <- adeq$PB3e / pmax(cte, 1) ; adeq$PB3eInd <- adeq$PB3eInd / pmax(cte, 1)
      adeq$PB3f <- adeq$PB3f / pmax(ctf, 1) ; adeq$PB3fInd <- adeq$PB3fInd / pmax(ctf, 1)
      
      adeq$PB1g <- adeq$PB1g / pmax(ctg, 1) ; adeq$PB1gInd <- adeq$PB1gInd / pmax(ctg, 1)
      adeq$PB2g <- adeq$PB2g / pmax(ctg, 1) ; adeq$PB2gInd <- adeq$PB2gInd / pmax(ctg, 1)
      adeq$PB3g <- adeq$PB3g / pmax(ctg, 1) ; adeq$PB3gInd <- adeq$PB3gInd / pmax(ctg, 1)
  }

  if (0) { # Not necessary, normalization already above
      adeq$PF1 <- adeq$PF1 / pmax(ct, 1) ; adeq$PF1Ind <- adeq$PF1Ind / pmax(ct, 1)
      adeq$PF2 <- adeq$PF2 / pmax(ct, 1) ; adeq$PF2Ind <- adeq$PF2Ind / pmax(ct, 1)
      adeq$PF3 <- adeq$PF3 / pmax(ct, 1) ; adeq$PF3Ind <- adeq$PF3Ind / pmax(ct, 1)
  
      adeq$PF1e <- adeq$PF1e / pmax(cte, 1) ; adeq$PF1eInd <- adeq$PF1eInd / pmax(cte, 1)
      adeq$PF1f <- adeq$PF1f / pmax(ctf, 1) ; adeq$PF1fInd <- adeq$PF1fInd / pmax(ctf, 1)
      adeq$PF2e <- adeq$PF2e / pmax(cte, 1) ; adeq$PF2eInd <- adeq$PF2eInd / pmax(cte, 1)
      adeq$PF2f <- adeq$PF2f / pmax(ctf, 1) ; adeq$PF2fInd <- adeq$PF2fInd / pmax(ctf, 1)
      adeq$PF3e <- adeq$PF3e / pmax(cte, 1) ; adeq$PF3eInd <- adeq$PF3eInd / pmax(cte, 1)
      adeq$PF3f <- adeq$PF3f / pmax(ctf, 1) ; adeq$PF3fInd <- adeq$PF3fInd / pmax(ctf, 1)
      
      adeq$PF1g <- adeq$PF1g / pmax(ctg, 1) ; adeq$PF1gInd <- adeq$PF1gInd / pmax(ctg, 1)
      adeq$PF2g <- adeq$PF2g / pmax(ctg, 1) ; adeq$PF2gInd <- adeq$PF2gInd / pmax(ctg, 1)
      adeq$PF3g <- adeq$PF3g / pmax(ctg, 1) ; adeq$PF3gInd <- adeq$PF3gInd / pmax(ctg, 1)
  }

#  adeq$rndText <- rep ("ncj", round(runif(1)*100))

