
parFac <- 1
GetLLCallArgs <- c()   
GetLLCallVals <- c()

TexFileIn <- paste ("../tex-pars/In-", baseName, ".tex", sep="")
if (file.exists (TexFileIn)) unlink (TexFileIn)

TexFileOut <- paste ("../tex-pars/Out-", baseName, ".tex", sep="")
if (file.exists (TexFileOut)) unlink (TexFileOut)

TexFileRSq <- paste ("../tex-pars/RSq-", baseName, ".tex", sep="")
if (file.exists (TexFileRSq)) unlink (TexFileRSq)

TexFileMDev <- paste ("../tex-pars/MDev-", baseName, ".tex", sep="")
if (file.exists (TexFileMDev)) unlink (TexFileMDev)

TexFileDiff <- paste ("../tex-pars/Diff-", baseName, ".tex", sep="")
if (file.exists (TexFileDiff)) unlink (TexFileDiff)

TexFileSumm <- paste ("../tex-pars/Summ-", baseName, ".tex", sep="")
if (file.exists (TexFileSumm)) unlink (TexFileSumm)


LOGtex <- FALSE
LOG <- FALSE

AnzTypes <- 1

TypeAlpha <- 5
TypeBeta <- 6




printPredictedMeanSD <- function (treat, pars) {

  ReprSubj <- RefData$ID[RefData$Treat==treat][1]

  empMean <- mean (RefData$NormPass[RefData$Treat==treat])
  empSD <- sd (RefData$NormPass[RefData$Treat==treat])

  lineNr <- (1:length(RefData$Up))[RefData$Treat==treat][1]
  AnzStrats <- RefData$Up[lineNr] + 1
  pred <- rep (0, AnzStrats)
  shares <- pars[1 + (1:AnzTypes - 1) * (AnzTypePars+1)]
  typeVars <- rep (0, AnzTypes)
  avMode <- 0

  if (baseName=="opt-s1g" && AnzTypes==1) {
    fname <- paste ("../tex-pars/effic-", baseName, "-", AnzTypes, ".tex", sep="")
    if (treat==1) efficFile <- file(fname, "w")
    else efficFile <- file(fname, "a")
  }

  for (type in 1:AnzTypes) {
    StratProbs <- GetIndivTypeStrat (pars, type, subj=ReprSubj, treat)
    cat ("Treat", treat, "Type", type, "\t:", round(StratProbs, digits=3), "\n")
    pred <- pred + shares[type] * StratProbs
    myMode1 <- which.max(StratProbs)
    myMode2 <- which.max(StratProbs[3:length(StratProbs)-1]) + 1
    if (abs(myMode1-myMode2)>1) myMode <- myMode2 else myMode <- myMode1
    avMode <- avMode + shares[type] * (AnzStrats:1-1)[myMode]
    typeVars[type] <- sum(StratProbs*(AnzStrats:1-1)^2) - sum(StratProbs * AnzStrats:1-1)^2

    if (baseName=="opt-s1g" && AnzTypes==1) {
      utils <- rep (0, AnzStrats)
      for (strat in 1:AnzStrats) utils[strat] <- UCESAltr(strat, pars[4:5], treat)
      
      EU1 <- sum (utils * GetIndivTypeStrat (pars, type, subj=ReprSubj, treat))
      c1 <- calculCount
      
      pars2 <- pars
      pars2[4] <- 1e-03 ; EU2 <- sum (utils * GetIndivTypeStrat (pars2, type, subj=ReprSubj, treat))
      c2 <- calculCount
      pars2[2] <- 1e04  ; EU3 <- max (utils)

      cat ("Utilities (treat =", treat, "): Grid/Max =", round(EU1/EU3, digits=3), " \tMult/Max =", round(EU2/EU3, digits=3), " \tGrid/Mult =", round(EU1/EU2, digits=3), "\t calculs:", round(c1, digits=2), "/", round(c2, digits=2), "=", round(c1/c2, digits=3), "\n")

      cat (treat, "&", round(EU1/EU3, digits=3), "&", round(EU2/EU3, digits=3), "&", round(EU1/EU2, digits=3), "& $", round(c1, digits=2), "/", round(c2, digits=2), "=", round(c1/c2, digits=3), "$ \\\\\n", file=efficFile)

    }
  }
  
  if (baseName=="opt-s1g" && AnzTypes==1) close (efficFile)

  if (0) {
    cat ("Treat", treat, "Empir \t: ")
    for (i in 0:AnzStrats) {
      nj <- sum(RefData$NormPass[RefData$Treat==treat]==AnzStrats-i)
      cat (round (nj/176, digits=3), " ")
    }
    cat ("\nTreat", treat, "Aggreg \t:", round(pred, digits=3), "\n\n")
  }
  
  
  w <- ceiling(AnzStrats/csqNum)
  for (i in 0:ceiling(AnzStrats/w)) {
    if (i==0) {
      nj <- sum(RefData$NormPass[RefData$Treat==treat]==AnzStrats-i)
      mj <- pred[i+1]*176
    } else {
      nj <- sum(RefData$NormPass[RefData$Treat==treat]>=max(0,AnzStrats-i*w) & RefData$NormPass[RefData$Treat==treat]<AnzStrats-(i-1)*w)
      mj <- sum(pred[((i-1)*w+1):min(i*w, AnzStrats)+1])*176      
    }
    csqPred1[treat,i+1] <<- csqPred1[treat,i+1] + mj
    csqObs1[treat,i+1] <<- csqObs1[treat,i+1] + nj
    
    csqPred2[i+1] <<- csqPred2[i+1] + mj
    csqObs2[i+1] <<- csqObs2[i+1] + nj
  }

  if (abs (1-sum(pred)) > .01)
    cat ("Summe =", round (sum(pred), digits=3), "=", round (pred, digits=3), "\n")

  predMean <- sum (pred * AnzStrats:1-1)
  predM2 <- sum (pred * (AnzStrats:1-1)^2)
  predSD <- sqrt (predM2 - predMean^2)

  if (LOGtex) cat ("\tTreat", treat, ":",
                   "\tEmp = (", paste(round (empMean, digits=2), round(empSD, digits=2), sep=","), ")", 
                   "\tPred = (", paste(round (predMean, digits=2), round(predSD, digits=2), sep=","), ")",
                   "\ttype-SD = (", paste(round (sqrt(typeVars), digits=2), sep=","), ")",
                   "\n")

  dev <- sqrt((empMean-predMean)^2 + (empSD-predSD)^2)
  mad <- abs (empMean-predMean) * length(RefData$NormPass[RefData$Treat==treat])
  mrd <- abs (empMean-predMean) / empMean
  mod <- (AnzStrats-avMode) / (AnzStrats - empMean)
  return (c(dev, mad, mrd, mod))
}

saveTypesTable <- function (treat, pars) {

  ReprSubj <- RefData$ID[RefData$Treat==treat][1]

  empMean <- mean (RefData$NormPass[RefData$Treat==treat])
  empSD <- sd (RefData$NormPass[RefData$Treat==treat])

  lineNr <- (1:length(RefData$Up))[RefData$Treat==treat][1]
  AnzStrats <- RefData$Up[lineNr] + 1
  shares <- pars[1 + (1:AnzTypes - 1) * (AnzTypePars+1)]
  typeVars <- rep (0, AnzTypes)
#  for (type in 1:AnzTypes) {
#    StratProbs <- GetIndivTypeStrat (pars, type, subj=ReprSubj, treat)
#    typeVars[type] <- sum(StratProbs*(AnzStrats:1-1)^2) - sum(StratProbs * AnzStrats:1-1)^2
#  }

  if (exists("TypeAlpha") && exists ("TypeBeta")) {
    fname <- paste ("../tex-pars/Types-", baseName, "-", AnzTypes, ".tex", sep="")
    zz <- file(fname, "w")
    for (type in 1:AnzTypes) {
      p <- round (c(pars[TypeAlpha + (type - 1) * (AnzTypePars+1)],
                    pars[TypeBeta + (type - 1) * (AnzTypePars+1)],
                    shares[type], sqrt(pmax(0,typeVars))[type]), digits=3)
      if (type==5) cat (" \\\\\n", file=zz)
      cat (" && $\\begin{array}{cc}", p[1], "&", p[2], "\\\\", p[3], "&", round(p[4], digits=1), "\\end{array}$ ",
#           " & $\\begin{array}{c}", p[3], "\\\\", round(p[4], digits=1), "\\end{array}$ ",
           file = zz)
    }
    cat(paste("&", round (res$minimum, digits=2), ""), file = zz)
    close(zz)
  }
}

printToFile <- function (fname, numberV, nDigits=3, extra="", delAnzTypes=1) {
  fn <- paste (fname, extra, sep="")
  if (AnzTypes==delAnzTypes) zz <- file (fn, "w") else zz <- file (fn, "a")
  for (number in numberV)
    cat(paste("&", round (number, digits=nDigits), ""), file = zz)
  close(zz)
}

printTexFiles <- function (LL1, LL2, LL3, optPars) {

  absMin <- 5814
  cat ("AnzTypes =", AnzTypes, "\t In =", round (LL1, digits=3), "\t Out =", round (LL2, digits=3), "\t Ext =", round (LL3, digits=3), "\n")

  # File-Suffices
  # "" - LL (In/Out)
  # 1 - ICL-BIC
  # 2 - CLC (In/Out)
  # 3 - LL (Ext)
  # 4 - CLC (Ext)

  printToFile (TexFileIn, CLC0, 0, "1")
  if (AnzTypes>7) return ()
  
  printToFile (TexFileIn, LL1, 0)
  printToFile (TexFileOut, LL2, 0)
  printToFile (TexFileOut, LL3, 0, "3")
  printToFile (TexFileDiff, LL2 - LL1, 0)
  
  printToFile (TexFileIn, CLC1, 0, "2")
  printToFile (TexFileOut, CLC2, 0, "2")
  printToFile (TexFileOut, CLC3, 0, "4")
  printToFile (TexFileDiff, CLC2 - CLC1, 0, "2")
  
  rsq1 <- round (1 - LL1 / absMin, digits=4)
  rsq2 <- round (1 - LL2 / absMin, digits=4)

  cat ("\t RSq\t In =", round (rsq1, digits=3), "\t Out =", round (rsq2, digits=3), "\n")
  printToFile (TexFileRSq, rsq2)
  
  sum <- rep (0, 4)
  csqNum <<- 5   # =>  5+1 (Null zaehlt extra)
  csq <<- 0
  
  csqPred1 <<- array (0, c(AnzTreat,csqNum+1))
  csqObs1 <<- array (0, c(AnzTreat,csqNum+1))
  csqPred2 <<- rep (0, csqNum+1)
  csqObs2 <<- rep (0, csqNum+1)
#  for (treat in 1:AnzTreat) sum <- sum + printPredictedMeanSD (treat, optPars[,treat]) / AnzTreat

  csq <- 0
  for (treat in 1:AnzTreat)
    csq <- csq + sum ((csqPred1[treat,]-csqObs1[treat,])^2 / csqPred1[treat,])
  cat ("Chi-Sq = ", csq, "  =>  p =", 1-pchisq (csq, df=(csqNum+1)*AnzTreat-1), "\n")

  csq2 <- sum ((csqPred2-csqObs2)^2 / csqPred2)
  cat ("Chi-Sq2 = ", csq2, "  =>  p =", 1-pchisq (csq2, df=csqNum), "\n")
  
  cat ("meanDev =", round(sum, digits=4), "\n")
  
  printToFile (TexFileMDev, sum[3], 3)
  
  printToFile (TexFileSumm, c(LL2), 0, AnzTypes, AnzTypes)
  printToFile (TexFileSumm, c(rsq2, sum[2:4]), 3, AnzTypes, 0)

  AnzTypesB <- paste (AnzTypes, "b", sep="")
  printToFile (TexFileSumm, c(CLC2), 0, AnzTypesB, AnzTypes)
  printToFile (TexFileSumm, c(rsq2, sum[2:4]), 3, AnzTypesB, 0)

  AnzTypesS <- paste (AnzTypes, "s", sep="")
  printToFile (TexFileSumm, sum[c(2,3)], 3, AnzTypesS, AnzTypes)

  AnzTypesS <- paste (AnzTypes, "t", sep="")
  printToFile (TexFileSumm, sum[c(3,4)], 3, AnzTypesS, AnzTypes)
}

saveLLs <- function (LLv, suff) {
  fname <- paste ("../LLs/", baseName, "-", AnzTypes, "-", suff, ".rda", sep="")
  zz <- file(fname, "w")
  cat ("  ", suff, " => ", sum(LLv), "\n")
  cat("x <- c(", paste(LLv, collapse=","), ")\n", file = zz)
  close(zz)
}

saveCLCs <- function (CLCv, suff) {
  fname <- paste ("../LLs/", baseName, "-", AnzTypes, "-", suff, "-clc.rda", sep="")
  zz <- file(fname, "w")
  cat ("  ", suff, " => ", sum(CLCv), "\n")
  cat("x <- c(", paste(CLCv, collapse=","), ")\n", file = zz)
  close(zz)
}

TempLLv <- rep (0, AnzSubj)
TempCLCv <- rep (0, AnzSubj)

setTempLLv <- function (ll=0) {
  if (LOGtex) cat ("Temp: ", round(sum(TempLLv), digits=2), "+ ")
  TempLLv <<- lastIndivLL

  TempCLCv <<- lastIndivLL
  for (subj in 1:AnzSubj) {
    lastPostClass[subj,] <- pmax (1e-10, lastPostClass[subj,])
    TempCLCv[subj] <<- TempCLCv[subj] + sum (lastPostClass[subj,] * log (lastPostClass[subj,]))
  }
  
  if (LOGtex) cat (round(sum(lastIndivLL), digits=2), "=> \tLL =", round(sum(TempLLv), digits=2), "\tCLC =", round(sum(TempCLCv), digits=2), "\n")

  return (ll)
}

addTempLLv <- function (ll=0) {
  if (LOGtex) cat ("Temp: ", round(sum(TempLLv), digits=2), "+ ")
  TempLLv <<- TempLLv + lastIndivLL
  
  TempCLCv <<- TempCLCv + lastIndivLL
  for (subj in 1:AnzSubj) {
    lastPostClass[subj,] <- pmax (1e-10, lastPostClass[subj,])
    TempCLCv[subj] <<- TempCLCv[subj] + sum (lastPostClass[subj,] * log (lastPostClass[subj,]))
  }

  if (LOGtex) cat (round(sum(lastIndivLL), digits=2), "=> \tLL =", round(sum(TempLLv), digits=2), "\tCLC =", round(sum(TempCLCv), digits=2), "\n")
  
  return (ll)
}

setLastMoms <- function (x, RelTr) {
    x <- array (0, c(10, 8))   # Just a dummy function, for compatibility with the other data sets
    return (x)
}

makeFitPlot <- function (baseLab, exp1, exp2) { # another dummy
  return (1)
}

################################################################

LL <- array (0, c(5,5))
CLC <- array (0, c(5,5))

if (!exists("RelAnzTypes")) RelAnzTypes <- 1:8

for (AnzTypes in RelAnzTypes) {
  if (AnzTypes>3) next
  
  empiricalEntropy <- TRUE
  adeq <- list (LLmax=0, LLmin=0)
  adeq$LLmax <- calcLLmax (RelTr=InTreats0)
  adeq$LLmaxInd <- lastIndivLL
  adeq$LLmin <- calcLLmin (RelTr=InTreats0)
  adeq$LLminInd <- lastIndivLL
  empiricalEntropy <- FALSE
  
  okay <- rep ("", 5)
  
  rm (list=ls(pattern="prLevs"))

  DataFile <- paste ("RData/", baseName, ".Rdata", sep="")
  ResFile <- paste (DataFile, ".res", AnzTypes, sep="")
  if (!file.exists(ResFile)) next
  
  load (ResFile)
  ll <- GetLL (res$estimate, RelTr=OutTreats3) ; LL1 <- ll ; CLC1 <- calcCLC (ll) ; setTempLLv ()
  ll <- GetLL (res$estimate, RelTr=OutTreats4) ; LL1 <- LL1 + ll ; CLC1 <- CLC1 + calcCLC (ll) ; addTempLLv ()
  ll <- GetLL (res$estimate, RelTr=OutTreats2) ; LL1 <- LL1 + ll ; CLC1 <- CLC1 + calcCLC (ll) ; addTempLLv ()
  ll <- GetLL (res$estimate, RelTr=OutTreats1) ; LL1 <- LL1 + ll ; CLC1 <- CLC1 + calcCLC (ll) ; addTempLLv ()
  saveLLs (TempLLv, "in")
  saveCLCs (TempCLCv, "in")
  saveTypesTable (8, res$estimate)
  
  bicPen <- (length(res$estimate)-1) * log(AnzObs) /2
  LL[1,1] <- GetLL (res$estimate, RelTr=InTreats0) ; CLC[1,1] <- calcCLC (LL[1,1])
  CLC0 <- calcCLC (LL[1,1] + bicPen)
  
  adeq$LL <- LL[1,1]
  adeq$LLInd <- lastIndivLL
  adeq$EW <- -3*LL[1,1] ; adeq$EWInd <- -3*lastIndivLL           # Subtraction of in-sample part
  
  adeq$BIC <- CLC0              # BIC actually is CLC
  adeq$BICInd <- lastCLC - rep (bicPen/AnzSubj, AnzSubj)
  
  setTempLLv ()
  saveLLs (TempLLv, "all")
  saveCLCs (TempCLCv, "all")
  LL[1,2] <- GetLL (res$estimate, RelTr=InTreats1) ; CLC[1,2] <- calcCLC (LL[1,2])
  adeq$PWa <- LL[1,2] ; adeq$PWaInd <- lastIndivLL
  LL[1,3] <- GetLL (res$estimate, RelTr=InTreats2) ; CLC[1,3] <- calcCLC (LL[1,3])
  adeq$PWa <- adeq$PWa + LL[1,3] ; adeq$PWaInd <- adeq$PWaInd + lastIndivLL
  LL[1,4] <- GetLL (res$estimate, RelTr=InTreats3) ; CLC[1,4] <- calcCLC (LL[1,4])
  adeq$PWa <- adeq$PWa + LL[1,4] ; adeq$PWaInd <- adeq$PWaInd + lastIndivLL
  LL[1,5] <- GetLL (res$estimate, RelTr=InTreats4) ; CLC[1,5] <- calcCLC (LL[1,5])
  adeq$PWa <- adeq$PWa + LL[1,5] ; adeq$PWaInd <- adeq$PWaInd + lastIndivLL

  optPars <- array (0, dim=c(AnzTypes * (AnzTypePars+1), 50))

  DataFile <- paste ("RData/", baseName, "-red.Rdata", sep="")
  ResFile <- paste (DataFile, ".res", AnzTypes, sep="")
  if (!file.exists(ResFile)) next
  load (ResFile)
  LL2 <- GetLL (res$estimate, RelTr=OutTreats1) ; CLC2 <- calcCLC (LL2) ; setTempLLv ()
  optPars[,OutTreats1] <- res$estimate
  adeq$PW <- LL2 ; adeq$PWInd <- lastIndivLL
  LL[2,1] <- GetLL (res$estimate, RelTr=InTreats0) ; CLC[2,1] <- calcCLC (LL[2,1])
  adeq$EW <- adeq$EW+LL[2,1] ; adeq$EWInd <- adeq$EWInd+lastIndivLL                    # Extension from sub-sample to full
  saveLLs (lastIndivLL, "all1")
  LL[2,2] <- GetLL (res$estimate, RelTr=InTreats1) ; CLC[2,2] <- calcCLC (LL[2,2])
  LL3 <- GetLL2 (res$estimate, RelTr=OutTreats1) ; CLC3 <- calcCLC (LL3) ; ll3V <- lastIndivLL ; clc3V <- lastCLC  
  LL[2,3] <- GetLL (res$estimate, RelTr=InTreats2) ; CLC[2,3] <- calcCLC (LL[2,3])
  LL[2,4] <- GetLL (res$estimate, RelTr=InTreats3) ; CLC[2,4] <- calcCLC (LL[2,4])
  LL[2,5] <- GetLL (res$estimate, RelTr=InTreats4) ; CLC[2,5] <- calcCLC (LL[2,5])

  DataFile <- paste ("RData/", baseName, "-red2.Rdata", sep="")
  ResFile <- paste (DataFile, ".res", AnzTypes, sep="")
  if (!file.exists(ResFile)) next
  load (ResFile)
  ll <- GetLL (res$estimate, RelTr=OutTreats2) ; LL2 <- LL2 + ll ; CLC2 <- CLC2 + calcCLC (ll) ; addTempLLv ()
  optPars[,OutTreats2] <- res$estimate
  adeq$PW <- LL2 ; adeq$PWInd <- adeq$PWInd + lastIndivLL
  LL[3,1] <- GetLL (res$estimate, RelTr=InTreats0) ; CLC[3,1] <- calcCLC (LL[3,1])
  adeq$EW <- adeq$EW + LL[3,1] ; adeq$EWInd <- adeq$EWInd + lastIndivLL
  saveLLs (lastIndivLL, "all2")
  LL[3,2] <- GetLL (res$estimate, RelTr=InTreats1) ; CLC[3,2] <- calcCLC (LL[3,2])
  LL[3,3] <- GetLL (res$estimate, RelTr=InTreats2) ; CLC[3,3] <- calcCLC (LL[3,3])
  ll <- GetLL2 (res$estimate, RelTr=OutTreats2) ; LL3 <- LL3 + ll ; CLC3 <- CLC3 + calcCLC (ll) ; ll3V <- ll3V + lastIndivLL ; clc3V <- clc3V + lastCLC
  LL[3,4] <- GetLL (res$estimate, RelTr=InTreats3) ; CLC[3,4] <- calcCLC (LL[3,4])
  LL[3,5] <- GetLL (res$estimate, RelTr=InTreats4) ; CLC[3,5] <- calcCLC (LL[3,5])

  DataFile <- paste ("RData/", baseName, "-red3.Rdata", sep="")
  ResFile <- paste (DataFile, ".res", AnzTypes, sep="")
  if (!file.exists(ResFile)) next
  load (ResFile)
  ll <- GetLL (res$estimate, RelTr=OutTreats3) ; LL2 <- LL2 + ll ; CLC2 <- CLC2 + calcCLC (ll) ; addTempLLv ()
  adeq$PW <- LL2 ; adeq$PWInd <- adeq$PWInd + lastIndivLL
  optPars[,OutTreats3] <- res$estimate
  LL[4,1] <- GetLL (res$estimate, RelTr=InTreats0) ; CLC[4,1] <- calcCLC (LL[4,1])
  adeq$EW <- adeq$EW + LL[4,1] ; adeq$EWInd <- adeq$EWInd + lastIndivLL
  saveLLs (lastIndivLL, "all3")
  LL[4,2] <- GetLL (res$estimate, RelTr=InTreats1) ; CLC[4,2] <- calcCLC (LL[4,2])
  LL[4,3] <- GetLL (res$estimate, RelTr=InTreats2) ; CLC[4,3] <- calcCLC (LL[4,3])
  LL[4,4] <- GetLL (res$estimate, RelTr=InTreats3) ; CLC[4,4] <- calcCLC (LL[4,4])
  ll <- GetLL2 (res$estimate, RelTr=OutTreats3) ; LL3 <- LL3 + ll ; CLC3 <- CLC3 + calcCLC (ll) ; ll3V <- ll3V + lastIndivLL ; clc3V <- clc3V + lastCLC
  LL[4,5] <- GetLL (res$estimate, RelTr=InTreats4) ; CLC[4,5] <- calcCLC (LL[4,5])

  DataFile <- paste ("RData/", baseName, "-red4.Rdata", sep="")
  ResFile <- paste (DataFile, ".res", AnzTypes, sep="")
  if (!file.exists(ResFile)) next
  load (ResFile)
  ll <- GetLL (res$estimate, RelTr=OutTreats4) ; LL2 <- LL2 + ll ; CLC2 <- CLC2 + calcCLC (ll) ; addTempLLv ()
  adeq$PW <- LL2 ; adeq$PWInd <- adeq$PWInd + lastIndivLL
  saveLLs (TempLLv, "out")
  saveCLCs (TempCLCv, "out")
  
  optPars[,OutTreats4] <- res$estimate
  LL[5,1] <- GetLL (res$estimate, RelTr=InTreats0) ; CLC[5,1] <- calcCLC (LL[5,1])
  adeq$EW <- adeq$EW + LL[5,1] + bicPen ; adeq$EWInd <- adeq$EWInd + lastIndivLL - rep (bicPen/AnzSubj, AnzSubj)
  saveLLs (lastIndivLL, "all4")
  LL[5,2] <- GetLL (res$estimate, RelTr=InTreats1) ; CLC[5,2] <- calcCLC (LL[5,2])
  LL[5,3] <- GetLL (res$estimate, RelTr=InTreats2) ; CLC[5,3] <- calcCLC (LL[5,3])
  LL[5,4] <- GetLL (res$estimate, RelTr=InTreats3) ; CLC[5,4] <- calcCLC (LL[5,4])
  LL[5,5] <- GetLL (res$estimate, RelTr=InTreats4) ; CLC[5,5] <- calcCLC (LL[5,5])
  
  ll <- GetLL2 (res$estimate, RelTr=OutTreats4) ; LL3 <- LL3 + ll ; CLC3 <- CLC3 + calcCLC (ll) ; ll3V <- ll3V + lastIndivLL ; clc3V <- clc3V + lastCLC
  saveLLs (ll3V, "ext")
  saveCLCs (clc3V, "ext")



  if (LL[1,1] > min (LL[,1])) okay[1] <- which.min (LL[,1])
  if (LL[2,2] > min (LL[,2])) okay[2] <- which.min (LL[,2])
  if (LL[3,3] > min (LL[,3])) okay[3] <- which.min (LL[,3])
  if (LL[4,4] > min (LL[,4])) okay[4] <- which.min (LL[,4])
  if (LL[5,5] > min (LL[,5])) okay[5] <- which.min (LL[,5])

  printTexFiles (LL1, LL2, LL3, optPars)
  
  cat ("Fit to all data: In =", round (LL[1,1]), "\tOut =", round(c(LL[2,1],LL[3,1],LL[4,1],LL[5,1])), "  \t", okay[1], "\n")
  for (t in 2:5)
    cat ("Fit to subset", t-1, ": In =", round (LL[1,t]), "\tOut =", round(c(LL[2,t],LL[3,t],LL[4,t],LL[5,t])), "  \t", okay[t], "\n")

  
  cat("\n")
  if (CLC[1,1] > min (CLC[,1])) okay[1] <- which.min (CLC[,1])
  if (CLC[2,2] > min (CLC[,2])) okay[2] <- which.min (CLC[,2])
  if (CLC[3,3] > min (CLC[,3])) okay[3] <- which.min (CLC[,3])
  if (CLC[4,4] > min (CLC[,4])) okay[4] <- which.min (CLC[,4])
  if (CLC[5,5] > min (CLC[,5])) okay[5] <- which.min (CLC[,5])
  
  cat ("Fit to all data: In =", round (CLC[1,1]), "\tOut =", round(c(CLC[2,1],CLC[3,1],CLC[4,1],CLC[5,1])), "  \t", okay[1], "\n")
  for (t in 2:5)
    cat ("Fit to subset", t-1, ": In =", round (CLC[1,t]), "\tOut =", round(c(CLC[2,t],CLC[3,t],CLC[4,t],CLC[5,t])), "  \t", okay[t], "\n")

  cat ("\n-------------------------------------------------------\n\n")


  for (ex in c("", 1, 2, 3)) {
      TexFileExt <- paste ("../tex-pars/Ext-", baseName, "-t", AnzTypes, ".tex", ex, sep="")
      if (file.exists (TexFileExt)) unlink (TexFileExt)
  }
  TexFileExt <- paste ("../tex-pars/Ext-", baseName, "-t", AnzTypes, ".tex", ex, sep="")

  
  DataFile <- paste ("RData/", baseName, ".Rdata", sep="")
  ResFile <- paste (DataFile, ".res", AnzTypes, sep="")
  load (ResFile)


  source ("../extern-tex.R")
  
  AdeqFile <- paste ("Adeq/", baseName, "-t", AnzTypes, ".rda", sep="")
  save (adeq, file=AdeqFile)
  
  cat ("\n-------------------------------------------------------\n\n")
}

