
if (!exists("OptInterimPrint")) OptInterimPrint <- TRUE

maxLLFunc <- function (sp) {
  
  ParMin <- rep(baseParMin, AnzTypes)
  ParMax <- rep(baseParMax, AnzTypes)

  FixedParsFL <<- rep (FALSE, length(sp))
  if (doFixPars && AnzTypes>=4) FixedParsFL[1:(2*(AnzTypePars+1))] <<- TRUE
  else if (doFixPars && AnzTypes>=2) FixedParsFL[1:1*(AnzTypePars+1)] <<- TRUE
  FixedParsFL[1 + (1:AnzTypes - 1) * (AnzTypePars+1)] <<- FALSE
  FixedParsFL[4 + (1:AnzTypes - 1) * (AnzTypePars+1)] <<- FALSE
  FixedParsVals <<- sp

  if (0) {  # (!exists("CallCMAES") || CallCMAES) {
    library (cmaes)
    if (OptInterimPrint) cat ("Start CMAES\n")
    parFac <<- 1
    spOrig <- sp
    sp <- pmin (ParMax, pmax(ParMin, sp))
    sp <- NormalizeTypeShares (sp)
    FixedParsVals <<- sp
    g <- GetLLLog ; GetLLLog <<- OptInterimPrint ;
    while (1) {
      ll <- GetLL (sp) ; if (ll<5000) break
      sp[2 + (1:AnzTypes - 1) * (AnzTypePars+1)] <- sp[2 + (1:AnzTypes - 1) * (AnzTypePars+1)] / 2
    }
    GetLLLog <<- g

#    GetLLLog <- TRUE
    newShares <- rep (0, AnzTypes)
    for (i in 1:AnzTypes) newShares[i] <- sum(lastPostClass[,i]) / AnzSubj
    sharePars <- 1 + (1:AnzTypes - 1) * (AnzTypePars+1)
    sp[sharePars] <- newShares

#    parFac <<- sign(sp) * pmax (abs(sp), 0.01)
    FixedParsVals <<- sp
    facs <- rep (1.5, length(sp))
    facs[sharePars] <- 1.5
    r1 <- pmax(ParMin, pmin(sp/facs,sp*facs,spOrig))
    r2 <- pmin(ParMax, pmax(sp/facs,sp*facs,spOrig))
#    cat (sp, "\n", r1, "\n", r2, "\n")
    lb <- pmax(ParMin, r1)
    ub <- pmin(ParMax, r2)
    ub[ub==0] <- 0.05
    opt2 <- cma_es (fn=GetLL, par=sp/parFac,
                    lower=lb/parFac, upper=ub/parFac,
                    control=list(maxit=round(10*length(sp)^1.5)))
    if (OptInterimPrint) cat ("End CMAES  => ", opt2$value, "\n")
    
    if (opt2$value < ll) sp <- NormalizeTypeShares (opt2$par*parFac)
    sp[FixedParsFL] <- FixedParsVals[FixedParsFL]
  }
  


  if (1) for (iter in 1:1) {
#    if (OptInterimPrint) cat ("Start NEWUOA\n")
#  sp[4 + (1:AnzTypes - 1) * (AnzTypePars+1)] <- sp[4 + (1:AnzTypes - 1) * (AnzTypePars+1)] * 2/3
    parFac <<- 1
    sp <- pmin (ParMax, pmax(ParMin, sp))
    g <- GetLLLog ; GetLLLog <<- OptInterimPrint ; ll <- GetLL (sp) ; GetLLLog <<- g
  
    newShares <- rep (0, AnzTypes)
    for (i in 1:AnzTypes) newShares[i] <- sum(lastPostClass[,i]) / AnzSubj
#    sp[1 + (1:AnzTypes - 1) * (AnzTypePars+1)] <- newShares
    cat ("NEWUOA-sp:", sp, "\n")
    
    FixedParsVals <<- sp
#    GetLLLog <<- TRUE
    parFac <<- pmax (abs(sp), 0.2)
    opt2 <- newuoa (fn=GetLL, par=sp/parFac, control=list(rhobeg=0.5*iter, npt=2*length(sp)))
  
    sp <- NormalizeTypeShares (opt2$par*parFac)
    sp[FixedParsFL] <- FixedParsVals[FixedParsFL]
  }

#  if (OptInterimPrint) cat ("Start NLM\n")
  parFac <<- 1
  FixedParsFL <<- rep (FALSE, length(sp))
  sp <- pmin (ParMax, pmax(ParMin, sp))
  g <- GetLLLog ; GetLLLog <<- OptInterimPrint ; ll <- GetLL (sp) ; GetLLLog <<- g
  
  newShares <- rep (0, AnzTypes)
  for (i in 1:AnzTypes) newShares[i] <- sum(lastPostClass[,i]) / AnzSubj
  sp[1 + (1:AnzTypes - 1) * (AnzTypePars+1)] <- newShares
  
  if (exists ("myParScale") && length(myParScale)==length(sp)) res2 <- nlm (GetLL, sp, hessian=CalcHessianInNLM, typsize=myParScale, stepmax=rep(1, length(sp)))
  else res2 <- nlm (GetLL, sp, hessian=CalcHessianInNLM, typsize=pmax(abs(sp), 0.01), stepmax=rep(1, length(sp)))
  
  res2$estimate <- pmin (ParMax, pmax (res2$estimate))

  return (res2)
}


cat ("enter optim: sp =", round(sp, digits=3), "\n ap =", round(ap, digits=3), "\n")

if (!exists("MakeCorrectCheck")) MakeCorrectCheck <- TRUE
if (!exists("MakeRobustChecks")) MakeRobustChecks <- TRUE
if (!exists("AlwaysReoptimize")) AlwaysReoptimize <- FALSE

fp2 <- strsplit (fnameP2, "/")[[1]][1]
if (fp2=="test") {
    if (FoldNum==0) AlwaysReoptimize <- TRUE
    else AlwaysReoptimize <- FALSE
}

if (AlwaysReoptimize) cat ("\nAlwaysReoptimize !! \n\n")

ResFile <- paste (DataFile, ".res", AnzTypes, sep="")
if (!exists ("ap")) ap <- 0
if (length(ap) != length(sp)) ap <- 0

ParMin <- rep(baseParMin, AnzTypes)
ParMax <- rep(baseParMax, AnzTypes)
if (length(ap) != length(ParMin)) ap <- 0

CalcHessianInNLM <- TRUE
    
if (file.exists(ResFile)) {
  load (ResFile)
  if (max(c(length(res$estimate), length(res$gradient), dim(res$hessian))) > AnzTypes*(AnzTypePars+1)) {
      res$estimate <- res$estimate[1:(AnzTypes*(AnzTypePars+1))]
      res$gradient <- res$gradient[1:(AnzTypes*(AnzTypePars+1))]
      res$hessian <- res$hessian[1:(AnzTypes*(AnzTypePars+1)),1:(AnzTypes*(AnzTypePars+1))]
      save (res, file=ResFile)
  }
  
  parFac <- 1

  cat ("Previous estimate loaded: ")

  if (MakeCorrectCheck || AlwaysReoptimize) {
      g <- GetLLLog ; GetLLLog <- OptInterimPrint ; ll <- GetLL (res$estimate) ; GetLLLog <- g
      
      if (abs(ll-res$minimum)>1 || AlwaysReoptimize) {
          cat ("Recalc necessary (newLL =", round(ll, digits=1), " origLL =", round(res$minimum, digits=1),")\n")
          res <- maxLLFunc (res$estimate)
          save (res, file=ResFile)
      }
  }
  
} else {

  if (sum (sp)==0) sp <- calcStartPars (old)
  
  res <- maxLLFunc (sp)
  save (res, file=ResFile)
}

if (!exists("RetryTypesV")) RetryTypesV <- 0:0
if (AnzTypes %in% RetryTypesV && sum(ap)==0) ap <- res$estimate
if (MakeRobustChecks && sum(ap)!=0) {

  parFac <- 1
  res2 <- maxLLFunc (ap)
  
  if (res2$minimum < res$minimum) {
    res <- res2
    save (res, file=ResFile)
  }
}

if (0 && MakeRobustChecks && AnzTypes==1 && baseParMin[4]==0.2 && res$estimate[4]<=0.5) {
    ap <- res$estimate
    ap[4] <- 3
    ll <- GetLL (ap)
    cat ("High Sigma in ole:", ap, " \t=> ", ll, "(vs.", res$minimum, ")\n")
    
    res <- maxLLFunc (ap)
    save (res, file=ResFile)

}

resOrig <- res
if (MakeRobustChecks && !exists ("DontCrossCheck"))
for (subNum in 0:4) {
  
  if (!exists ("BaseLab")) BaseLab <- baseName
  
  if (0 && exists ("FLHarrData"))
      othResName <- paste ("RData/", baseName, DataSet, c("", "-red", "-red2", "-red3", "-red4")[subNum+1], ".Rdata.res", AnzTypes, sep="")
  else
      othResName <- paste ("RData/", BaseLab, c("", "-red", "-red2", "-red3", "-red4")[subNum+1], ".Rdata.res", AnzTypes, sep="")
  
  if (file.exists(othResName)) {
    load (othResName)
    parFac <- 1    
    ll <- GetLL (res$estimate)
    cat ("Other Fold", subNum, ":", othResName, " \t=> ", ll, "(vs.", resOrig$minimum, ")\n")
    if (ll < resOrig$minimum-0.1) {
      res <- maxLLFunc (res$estimate)
      save (res, file=ResFile)
      resOrig <- res
    }
  }
}
res <- resOrig

# Make more complete OthResTryV
ortV <- strsplit (baseName, "-")[[1]]

if (0 && length(ortV)>2 && ortV[1]=="fis" && (ortV[3]=="palm" || ortV[3]=="palm2" || ortV[3]=="palm3")) {

  op <- res$estimate
  
  if (MixMode<=3 && op[3]> 0.3) op[3] <- 0.1
  else if (MixMode>=4 && op[3]> -1) op[3] <- -2

  if (0 && op[3] != res$estimate[3]) {
    cat ("Try smaller rho", ":\t sp =", round(op, digits=3), "\n")
    res2 <- maxLLFunc (op)
    if (res2$minimum < res$minimum) {
      res <- res2
      save (res, file=ResFile)
      resOrig <- res
    }
  }
}


if (length(ortV)>2) ortV[2] <- "mix"
newORT <- c()
for (exp in c("garp", "harr", "capp", "list", "bard")) newORT <- c(newORT, paste (c(exp, ortV[2:length(ortV)]), collapse="-"))
for (model in c("logit", "ole", "prom", "palm2", "palm3")) newORT <- c(newORT, paste (c(ortV[2:length(ortV) - 1], model), collapse="-"))

OthResTryV <- setdiff (unique (newORT), baseName)
cat ("OthResTryV:", OthResTryV, "\n")


if (MakeRobustChecks && exists ("OthResTryV")) {
    
    resfV <- strsplit (ResFile, "-")[[1]]
    for (othResTry in OthResTryV) {
      othResfV <- strsplit (othResTry, "-")[[1]]
      if (othResfV[1]=="garp") othResfV[1] <- "opt"
      if (length(othResfV)>2)
          othResTryName <- paste ("../", othResTry, "/RData/", paste(othResfV[1], resfV[2], othResfV[3], sep="-"), SubsetLab, ".Rdata.res", AnzTypes, sep="")
      else
          othResTryName <- paste ("../", othResTry, "/RData/", othResTry, SubsetLab, ".Rdata.res", AnzTypes, sep="")
  
      if (file.exists(othResTryName)) {
          load (othResTryName)
          parFac <- 1
          ll <- GetLL (res$estimate)
          cat ("OthResTry", ":", othResTryName, "\n\t sp =", round(res$estimate, digits=3), " \t=> ", ll, "(vs.", resOrig$minimum, ")\n")
          if (ll < resOrig$minimum-0.1) {
              res <- maxLLFunc (res$estimate)
              save (res, file=ResFile)
              resOrig <- res
          }

          if (0) {
            load (othResTryName)
            parFac <- 1
            res$estimate[3 + (1:AnzTypes - 1) * (AnzTypePars+1)] <- 0.02
            res$estimate[4 + (1:AnzTypes - 1) * (AnzTypePars+1)] <- 0.05
            ll <- GetLL (res$estimate)
            cat ("OthResTry-2", ":", othResTryName, "\n\t sp =", round(res$estimate, digits=3), " \t=> ", ll, "(vs.", resOrig$minimum, ")\n")
            if (ll < resOrig$minimum - 0.1) {
              res <- maxLLFunc (res$estimate)
              save (res, file=ResFile)
              resOrig <- res
            }
          }
        }

    }
}
res <- resOrig

if (MakeRobustChecks && AnzTypes==1 && exists("MixTypesV")) {

  resfV <- strsplit (ResFile, "-")[[1]]

  
  for (AltMixMode in 1:5) {

    if (Moderate==0) altMod <- c("mix", "mix2", "mix3", "mix5", "mix7")[AltMixMode]
    if (Moderate==1) altMod <- c("mix9", "mix0", "mix4", "mix6", "mix8")[AltMixMode]
    if (Moderate==2) altMod <- c("mix10", "mix0", "mix11", "mix12", "mix13")[AltMixMode]
      
    if (altMod == resfV[2]) next
    othResTryName <- paste (c(resfV[1], altMod, resfV[3:length(resfV)]), collapse="-")

    
    if (file.exists(othResTryName)) {
      load (othResTryName)

      if (length(resOrig$estimate) != length(res$estimate)) next
      
      op <- res$estimate
      cat ("Conversion (", altMod, "):", round (op, digits=3), "\n")

      op[2] <- pmin (20, op[2])

      if (AnzTypePars==7) op <- op[1:(AnzTypePars+1)]
      else if (AltMixMode == 1 && AnzTypePars>7) op <- c(op[1], op[2], op[3:length(op)], 0.1)
      else {
          if (AltMixMode<3 && MixMode>3) {
              s <- op[c(2,9)]
              op[c(2,9)] <- c(log(s[1]^2 / sqrt(s[1]^2 + s[2]^2)), sqrt(log(1+s[2]^2/s[1]^2)))
          }
          if (MixMode==4) {
              if (AltMixMode==3) { op[3] <- log(pmax(1e-2, op[3])) ; op[4] <- 0.01 }
              if (AltMixMode==5) { op[2] <- log(pmax(1e-2, op[2])) ; op[9] <- 0.01 }
          }
          if (MixMode==5) {
              if (AltMixMode %in% 1:2) { op[3] <- log(pmax(1e-2, op[3])) ; op[4] <- 0.01 }
              if (AltMixMode==3) { op[2] <- pmin (20, exp(op[2])) ; op[3] <- log(pmax(1e-2, op[3])) ; op[4] <- 0.01 }
              if (AltMixMode==4) { op[2] <- pmin (20, exp(op[2])) }
          }
      }

      op <- pmin (1e20, pmax(-1e20, op))
      
      parFac <- 1
      ll <- GetLL (op)
      cat ("AltMod", ":", othResTryName, "\n\t sp =", round(op, digits=3), " \t=> ", ll, "(vs.", resOrig$minimum, ")\n")
      if (ll < resOrig$minimum-0.1) {
        res <- maxLLFunc (op)
        if (res$minimum < resOrig$minimum) {
          save (res, file=ResFile)
          resOrig <- res
        }
      }
    } else
      cat ("OthResTry", ":", othResTryName, " does not exist\n")
  }
  
  for (AltModerate in 0:2) {

    if (AltModerate==0) altMod <- c("mix", "mix2", "mix3", "mix5", "mix7")[MixMode]
    if (AltModerate==1) altMod <- c("mix9", "mix0", "mix4", "mix6", "mix8")[MixMode]
    if (AltModerate==2) altMod <- c("mix10", "mix0", "mix11", "mix12", "mix13")[MixMode]
      
    if (altMod == resfV[2]) next
    othResTryName <- paste (c(resfV[1], altMod, resfV[3:length(resfV)]), collapse="-")

    
    if (file.exists(othResTryName)) {
      load (othResTryName)
      
      op <- res$estimate
      cat ("Test (", altMod, "):", round (op, digits=3), "\n")

      op[2] <- pmin (200, resOrig$estimate[2])
      if (length(resOrig$estimate)>8) op[9] <- resOrig$estimate[9]
      op <- pmin (1e20, pmax(-1e20, op))
      
      parFac <- 1
      ll <- GetLL (op)
      cat ("AltMod", ":", othResTryName, "\n\t sp =", round(op, digits=3), " \t=> ", ll, "(vs.", resOrig$minimum, ")\n")
      if (ll < resOrig$minimum-0.1) {
        res <- maxLLFunc (op)
        if (res$minimum < resOrig$minimum) {
          save (res, file=ResFile)
          resOrig <- res
        }
      }
    } else
      cat ("OthResTry", ":", othResTryName, " does not exist\n")
  }

    
}
res <- resOrig


if (0 && MakeRobustChecks && exists("MixTypesV")) {
  shares <- sp[1 + (1:AnzTypes-1) * (AnzTypePars+1)]
  sr <- order (shares)
  ap <- c()
  for (i in sr)
    ap <- c(ap, sp[1:(AnzTypePars+1) + (i-1) * (AnzTypePars+1)])

  pp <- (pmin(AnzTypes, MixTypesV) - 1) * (AnzTypePars+1)
  ap[pp+5] <- pmax (-0.1, ap[pp+5])
  ap[pp+6] <- pmin (1, pmax (-3, ap[pp+6]))
  ap[2] <- pmax (0.05, ap[2])
  
  parFac <- 1
  res2 <- maxLLFunc (ap)
  
  if (res2$minimum < res$minimum) {
    res <- res2
    save (res, file=ResFile)
  }
}

if (0 && MakeRobustChecks && (exists("MixTypesV") || AnzTypes==2)) {
  ap <- res$estimate

  ap[2] <- 1
  ap[5] <- -1
  ap[6] <- 0.1
  
  parFac <- 1
  res2 <- maxLLFunc (ap)
  
  if (res2$minimum < res$minimum) {
    res <- res2
    save (res, file=ResFile)
  }
}

if (MakeRobustChecks && !exists ("DontUpCheck")) {

  resOrig <- res
  othResName <- paste (DataFile, ".res", AnzTypes+1, sep="")
  
  if (file.exists(othResName)) {
    load (othResName)
    shares <- res$estimate[1 + (0:AnzTypes) * (AnzTypePars+1)]
    sr <- setdiff (rev(order(shares)), order (shares)[1])
    sp <- c()
    for (i in sr)
      sp <- c(sp, res$estimate[1:(AnzTypePars+1) + (i-1) * (AnzTypePars+1)])
    
    parFac <- 1
    shV <- 1 + (1:AnzTypes-1) * (AnzTypePars+1)
    sp[max(shV)] <- sp[max(shV)] + 1-sum(sp[shV])
    sp <- pmin (ParMax, pmax(ParMin, sp))
    ll <- GetLL (sp)
    cat ("Upwards-Check: shares =", round(shares, digits=3), "  rev-rank =", sr, " \t=> ", ll, "(vs.", resOrig$minimum, ")\n")
    cat ("   sp <- c(", paste (round(sp, digits=3), collapse=","), ")\n")
    
    if (ll < resOrig$minimum-0.1) {
      res <- maxLLFunc (sp)
      if (res$minimum < resOrig$minimum) { save (res, file=ResFile) ; resOrig <- res }
    }
  }
}
res <- resOrig

shares <- res$estimate[1 + (1:AnzTypes-1) * (AnzTypePars+1)]
if (MakeRobustChecks && (min(shares)<0.02 || (AnzTypes>1 && exists ("oldVal") && oldVal>0 && res$minimum > oldVal - 0.1))){
  minT <- which.min (shares)
  maxT <- which.max (shares)
  sp <- res$estimate

  sp[1:(AnzTypePars+1) + (minT-1) * (AnzTypePars+1)] <- sp[1:(AnzTypePars+1) + (maxT-1) * (AnzTypePars+1)]
  sp[1 + (minT-1) * (AnzTypePars+1)] <- 0.111
  sp[1 + (1:AnzTypes-1) * (AnzTypePars+1)] <- sp[1 + (1:AnzTypes-1) * (AnzTypePars+1)] / sum(sp[1 + (1:AnzTypes-1) * (AnzTypePars+1)])
  
  if (1 || AnzTypes==2) {
    sp[2 + (minT-1) * (AnzTypePars+1)] <- max (1, sp[2 + (minT-1) * (AnzTypePars+1)] * 3)
    sp[5 + (minT-1) * (AnzTypePars+1)] <- -0.5
    sp[6 + (minT-1) * (AnzTypePars+1)] <- 0.1
    if (AnzTypePars==8) {
      sp[7 + (minT-1) * (AnzTypePars+1)] <- sp[5 + (minT-1) * (AnzTypePars+1)] / 2
      sp[8 + (minT-1) * (AnzTypePars+1)] <- sp[6 + (minT-1) * (AnzTypePars+1)] / 2
      sp[9 + (minT-1) * (AnzTypePars+1)] <- sp[2 + (minT-1) * (AnzTypePars+1)] / 2
    }
  } else if (AnzTypes==3) {
    sp[2 + (minT-1) * (AnzTypePars+1)] <- max (1, sp[2 + (minT-1) * (AnzTypePars+1)] * 2)
    sp[5 + (minT-1) * (AnzTypePars+1)] <- 0.3
    sp[6 + (minT-1) * (AnzTypePars+1)] <- -5
  } else {
    sp[2 + (minT-1) * (AnzTypePars+1)] <- max (1, sp[2 + (minT-1) * (AnzTypePars+1)] * 1.5)
    sp[5 + (minT-1) * (AnzTypePars+1)] <- sp[5 + (minT-1) * (AnzTypePars+1)] * 1.5
    sp[6 + (minT-1) * (AnzTypePars+1)] <- sp[6 + (minT-1) * (AnzTypePars+1)]/2
    if (AnzTypePars==8) {
      sp[7 + (minT-1) * (AnzTypePars+1)] <- sp[5 + (minT-1) * (AnzTypePars+1)] / 2
      sp[8 + (minT-1) * (AnzTypePars+1)] <- sp[6 + (minT-1) * (AnzTypePars+1)] / 2
      sp[9 + (minT-1) * (AnzTypePars+1)] <- sp[2 + (minT-1) * (AnzTypePars+1)] / 2
    }
  }

  parFac <- 1
  sp <- pmin (ParMax, pmax(ParMin, sp))
  ll <- GetLL (sp)
  cat ("Reset Zero-Weight-Component: shares =", round(shares, digits=3), "\n")
  cat ("   sp <- c(", paste (round(sp, digits=3), collapse=","), ")\n")
  
  res2 <- maxLLFunc (sp)
  if (res2$minimum < res$minimum) { res <- res2 ; save (res, file=ResFile) }
}


if (MakeRobustChecks && AnzTypes>1 && exists ("oldVal") && oldVal>0 && res$minimum > oldVal + 0.1) {

  cat ("Old-Val:", oldVal, "(vs.", res$minimum, ")\n")
  sp <- calcStartPars (old)
  res2 <- maxLLFunc (sp)
  
  if (res2$minimum < res$minimum) {
    res <- res2
    save (res, file=ResFile)
  }
}

if (MakeRobustChecks && !CalcHessianInNLM && is.null(res$HessCalcRichard)) {  # if null, then the result is new
  library (numDeriv)
  ParMin <- rep(baseParMin, AnzTypes)
  ParMax <- rep(baseParMax, AnzTypes)
  res$estimate <- pmin (ParMax, pmax (res$estimate))
  
  res$minimum <- GetLL (res$estimate, RelTr=RelTreats)
  res$hessian <- hessian (GetLL, res$estimate, method="Richardson", method.args=list(eps=1e-4, r=2), RelTr=RelTreats)   # default is r=4
  res$HessCalcRichard <- res$estimate       # save parameters, for which Hessian was computed
  save (res, file=ResFile)
}

oldVal <- res$minimum
