cat ("My pid:", Sys.getpid (), "\n\n")

RefData <- read.table (file="garp-dat.csv", header=T, sep=",")
data <- RefData[,2:9]
AnzTreat <- 8

Low <-  c(  0, 0,  0, 0,  0, 0, 0, 0)
Up <-   c(120,40,120,60,150,75,60,100)
Step <- c(  3, 1,  2, 1,  2, 1, 1, 1)
Rate <- c(1/3, 3,1/2, 2,1/2, 2, 1, 1)
DictEndow <- Up
RecEndow <- rep(0, AnzTreat)

#####################################################################

for (t in 1:8) {
  filename <- paste("hist-garp2-", t, ".pdf", sep="")
  pdf (filename, width=9, height=6)
  par(mar=c(5,4.5,4,2) + 0.1)

  s <- (Up[t]/Step[t] - data[,t]) / (Up[t]/Step[t])
  cat ("Treatment", t, ": Num =", length(s), "\tMean =", mean(s), "\tMean|s>0 =", mean(s[s>0]), "\tSD =", sd(s), "\n")
  
  hist(s,
       xlim=c(0,1), #ylim=c(0,120),
       breaks=0:100/100,
       main="",
#       main=list(paste("Treatment ", t, "  (B=", Up[t]/Step[t],", Tau1=", Step[t], ", ", expression(tau[2]), "=", Step[t]*Rate[t], ")", sep=""), cex=1.5),
       xlab=list("Budget share transfered", cex=1.8),
       ylab=list("Percentage of choices", cex=1.8),
       freq=FALSE,
       cex.axis=1.8)
  par(oma=c(2,2,2,2))
  dev.off()
}

sortRatioV <- c()
meanV <- c()
sdV <- c()
mean2V <- c()

for (n in 1:5) {
    if (n==1) tV <- 1
    if (n==2) tV <- c(3,5)
    if (n==3) tV <- c(7,8)
    if (n==4) tV <- c(4,6)
    if (n==5) tV <- c(2)

    s <- c()
    for (t in tV) s <- c(s, (Up[t]/Step[t] - data[,t]) / (Up[t]/Step[t]))

    sortRatioV <- c(sortRatioV, Rate[tV[1]])
    meanV <- c(meanV, mean(s))
    mean2V <- c(mean2V, mean(s[s>0]))
    sdV <- c(sdV, sd(s))
}

cat ("ratioGarp <- c(", paste(sortRatioV, collapse=","), ")\n")
cat ("meanGarp <- c(", paste(meanV, collapse=","), ")\n")
