
CappFullStratSpace <- TRUE
source ("../optim/capp-data.R")

library (ggplot2)
theme_set (theme_gray())

for (t in 1:AnzTreat) {

    filename <- paste("hist-capp2-", t, ".pdf", sep="")
#    pdf (filename, width=9, height=6)
#    par(mar=c(5,4.5,4,2) + 0.1)

    trData <- RefData[RefData$Treat==t,]

    if (0) {
        s <- trData$Pass / trData$Max.Pass
        xlimV <- c(0,1)
        breaksV <- 0:100/100
        mainStr <- ""
        xlabStr <- list("Budget share transfered", cex=1.8)
    } else {
        s <- trData$Pass
        xlimV <- c(0,max(trData$Max.Pass))
        breaksV <- (0*100):(max(trData$Max.Pass)*100)/100
        xlabStr <- "Tokens transfered"
        mainStr <- paste("CHST07: Treatment ", t, "  (B=", max(trData$Max.Pass),", Transfer 1:1)", sep="")
        par(lwd=5)
    }
    
    cat ("Treatment", t, ": Num =", length(s), "\tMean =", mean(s), "\tMean|s>0 =", mean(s[s>0]), "\tSD =", sd(s), "\n")

#    hist(s, xlim=xlimV, breaks=breaksV, main=mainStr, xlab=xlabStr,
#         ylab=list("Percentage of choices", cex=1.8), freq=FALSE, cex.axis=1.8)

    dat <- data.frame (s=s, title=as.factor(rep(mainStr, length(s))))
    ggplot(dat, aes (s)) + labs(x=xlabStr, y="Relative frequency") + geom_histogram(aes(y=..count../sum(..count..)), binwidth=5) + facet_grid(. ~ title) + ylim(0,1/3) +
        theme(strip.text.x = element_text(size = 22),
              # axis.title.y=element_text(size=22), axis.text.y=element_text(size=18),
              axis.title.y=element_blank(), axis.text.y=element_blank(), axis.ticks.y=element_blank(),
              axis.title.x=element_text(size=22), axis.text.x=element_text(size=18)
              )
    ggsave (filename, device="pdf")
#  par(oma=c(2,2,2,2))
#    dev.off()

}
