cat ("My pid:", Sys.getpid (), "\n\n")

RefData <- read.table (file="garp-dat.csv", header=T, sep=",")
data <- RefData[,2:9]
AnzTreat <- 8

Low <-  c(  0, 0,  0, 0,  0, 0, 0, 0)
Up <-   c(120,40,120,60,150,75,60,100)
Step <- c(  3, 1,  2, 1,  2, 1, 1, 1)
Rate <- c(1/3, 3,1/2, 2,1/2, 2, 1, 1)
TRatio <- c("3:1", "1:3", "2:1", "1:2", "2:1", "1:2", "1:1", "1:1")
DictEndow <- Up
RecEndow <- rep(0, AnzTreat)

filename <- ""
filename <- "hist-garp.pdf"

if (filename != "") pdf (filename, width=10, height=13)
  
layout (rbind(c(1,2),c(3,4),c(5,6),c(7,8)))
par(mar=c(5,4.5,4,2) + 0.1)

for (t in 1:AnzTreat) {
  up <- ceiling(Up[t]/Step[t]/10)*10
  dons <- Up[t]/Step[t] - data[,t]
  title <- paste("Treatment", t,
                 paste("(", TRatio[t], ", m=", round(mean(dons), digits=1),
                       ", s=", round(sd(dons), digits=1), ")", sep=""))
  hist(dons,
       xlim=c(0,up), ylim=c(0,120),
       breaks=0:round(up/5)*5,
       main=list(title, cex=2),
       xlab=list("Donation", cex=1.6),
       ylab=list("Frequency", cex=1.6),
       cex.axis=1.6)
}

if (filename != "") dev.off()

#######################################################

LL <- 0
AnzSubj <- dim(data)[1]
for (t in 1:AnzTreat)
  for (s in 1:AnzSubj) {
    LL <- LL + log (sum(data[,t]==data[s,t])/AnzSubj)
  }

cat ("LL =", round (LL, digits=2), "\n")
 # LL = -2449.27

########################################################

LL2 <- 0
AnzSubj <- dim(data)[1]
for (t in c(6,8))
  for (s in 1:AnzSubj) {
    LL2 <- LL2 + log (sum(data[,t]==data[s,t])/AnzSubj)
  }

cat ("LL2 =", round (LL2, digits=2), "\n")
 # LL2 = -642.85 



