cat ("My pid:", Sys.getpid (), "\n\n")

RefData <- read.table (file="garp-dat.csv", header=T, sep=",")
data <- RefData[,2:9]
AnzTreat <- 8

Low <-  c(  0, 0,  0, 0,  0, 0, 0, 0)
Up <-   c(120,40,120,60,150,75,60,100)
Step <- c(  3, 1,  2, 1,  2, 1, 1, 1)
Rate <- c(1/3, 3,1/2, 2,1/2, 2, 1, 1)
DictEndow <- Up
RecEndow <- rep(0, AnzTreat)

#####################################################################

library (ggplot2)
theme_set (theme_gray())

for (t in 1:8) {

    s <- Up[t]/Step[t] - data[,t]
    xlimV <- c(Low[t],Up[t]/Step[t])
    breaksV <- (Low[t]*100):(Up[t]*100)/100
    xlabStr <- "Tokens transfered"
    mainStr <- paste("AM02: Treatment ", t, "  (B=", Up[t]/Step[t],", Transfer ", Step[t], ":", Step[t]*Rate[t], ")", sep="")
    
    cat ("Treatment", t, ": Num =", length(s), "\tMean =", mean(s), "\tMean|s>0 =", mean(s[s>0]), "\tSD =", sd(s), "\n")
  
    filename <- paste("hist-garp2-", t, ".pdf", sep="")
#    pdf (filename, width=9, height=6)
    
    dat <- data.frame (s=s, title=as.factor(rep(mainStr, length(s))))
    ggplot(dat, aes (s)) + labs(x=xlabStr, y="Relative frequency") + geom_histogram(aes(y=..count../sum(..count..)), binwidth=1) + facet_grid(. ~ title) + ylim(0,1/3) +
        theme(strip.text.x = element_text(size = 22),
              axis.title.y=element_text(size=22), axis.text.y=element_text(size=18),
              # axis.title.y=element_blank(), axis.text.y=element_blank(), axis.ticks.y=element_blank(),
              axis.title.x=element_text(size=22), axis.text.x=element_text(size=18)
              )
    ggsave (filename, device="pdf", width=7.5, height=7)
#    dev.off()
}

XXX

sortRatioV <- c()
meanV <- c()
sdV <- c()
mean2V <- c()

for (n in 1:5) {
    if (n==1) tV <- 1
    if (n==2) tV <- c(3,5)
    if (n==3) tV <- c(7,8)
    if (n==4) tV <- c(4,6)
    if (n==5) tV <- c(2)

    s <- c()
    for (t in tV) s <- c(s, (Up[t]/Step[t] - data[,t]) / (Up[t]/Step[t]))

    sortRatioV <- c(sortRatioV, Rate[tV[1]])
    meanV <- c(meanV, mean(s))
    mean2V <- c(mean2V, mean(s[s>0]))
    sdV <- c(sdV, sd(s))
}

cat ("ratioGarp <- c(", paste(sortRatioV, collapse=","), ")\n")
cat ("meanGarp <- c(", paste(meanV, collapse=","), ")\n")
