
cat ("My pid:", Sys.getpid (), "\n\n")

AnzSubj <- 28
AnzTreat <- 10

AnzDat <- rep (AnzSubj, AnzTreat)
FullData <- read.table (file="altruism.csv", header=T, sep=",")
dat <- data.frame(id=FullData$id, tr=FullData$decision, cond=FullData$treat, resp=FullData$peasant, d=FullData$dec, endow=FullData$endow, self=FullData$self, other=FullData$other)


Low <-  rep(0, AnzTreat)
Step <- dat$self[1:AnzTreat] / 10
Rate <- dat$other[1:AnzTreat] / dat$self[1:AnzTreat]
Up <- dat$endow[1:AnzTreat] * Step
DictEndow <- Up
RecEndow <- rep(0, AnzTreat)


dat1 <- dat[dat$cond=="o" & dat$resp==0,]
SubjV1 <- levels(as.factor( (dat1$id)))
AnzSubj1 <- length(SubjV1)
data1 <- array (0, c(AnzSubj1, AnzTreat))

for (i in 1:AnzSubj1) {
    s <- SubjV1[i]
    d <- dat1$endow[dat1$id==s] - dat1$d[dat1$id==s]
    data1[i,] <- as.double (d)
}

dat2 <- dat[dat$cond=="oc" & dat$resp==0,]
SubjV2 <- levels(as.factor( (dat2$id)))
AnzSubj2 <- length(SubjV2)
data2 <- array (0, c(AnzSubj2, AnzTreat))

for (i in 1:AnzSubj2) {
    s <- SubjV2[i]
    d <- dat2$endow[dat2$id==s] - dat2$d[dat2$id==s]
    data2[i,] <- as.double (d)
}

data <- rbind(data1,data2)
AnzSubj <- dim(data)[1]

TRatio <- c("2:4", "2:6", "2:2", "2:4", "5:5", "1:2", "2:3", "2:4", "2:5", "2:8")

###########################################################################
###########################################################################
###########################################################################


filename <- ""
filename <- "hist-harr.pdf"

if (filename != "") pdf (filename, width=10, height=13)
  
layout (rbind(c(1,2),c(3,4),c(5,6),c(7,8),c(9,10)))
par(mar=c(5,4.5,4,2) + 0.1)

for (t in 1:AnzTreat) {
  up <- ceiling(Up[t]/Step[t]/10)*10
  dons <- Up[t]/Step[t] - data[,t]
  title <- paste("Treatment", t,
                 paste("(", TRatio[t], ", m=", round(mean(dons), digits=1),
                       ", s=", round(sd(dons), digits=1), ")", sep=""))
  hist(dons,
       xlim=c(0,up), ylim=c(0,25),
       breaks=0:round(up/5)*5,
       main=list(title, cex=2),
       xlab=list("Donation", cex=1.6),
       ylab=list("Frequency", cex=1.6),
       cex.axis=1.6)
}

if (filename != "") dev.off()

#######################################################

LL <- 0
AnzSubj <- dim(data)[1]
for (t in 1:AnzTreat)
  for (s in 1:AnzSubj) {
    LL <- LL + log (sum(data[,t]==data[s,t])/AnzSubj)
  }

cat ("LL =", round (LL, digits=2), "\n")
 # LL = -2449.27

