

source ("../optim/list-data.R")

library (ggplot2)
theme_set (theme_gray())

for (t in 1:AnzTreat) {

    filename <- paste("hist-list2-", t, ".pdf", sep="")
#    pdf (filename, width=9, height=6)
#    par(mar=c(5,4.5,4,2) + 0.1)

    trData <- data[t,1:AnzDat[t]]

    if (0) {
        s <- (trData-Low[t]) / (Up[t] - Low[t])
        xlimV <- c(0,1)
        breaksV <- 0:100/100
        xlabStr <- list("Budget share transfered", cex=1.8)
        mainStr <- ""
    } else {
        s <- trData
        xlimV <- c(Low[t],Up[t])
        breaksV <- (100*Low[t]):(100*Up[t]) / 100
        xlabStr <- "Tokens transfered"
        mainStr <- paste("List07: Treatment ", t, "  (B=", Up[t],", Transfer 1:1)", sep="")
        par(lwd=5)
    }
    
    cat ("Treatment", t, ": Num =", length(s), "\tMean =", mean(s), "\tMean|s>0 =", mean(s[s>0]), "\tSD =", sd(s), "\n")

#    hist(s, xlim=xlimV, breaks=breaksV, main=mainStr, xlab=xlabStr,
#         ylab=list("Percentage of choices", cex=1.8), freq=FALSE, cex.axis=1.8)
  
    dat <- data.frame (s=s, title=as.factor(rep(mainStr, length(s))))
    ggplot(dat, aes (s)) + labs(x=xlabStr, y="Relative frequency") + geom_histogram(aes(y=..count../sum(..count..)), binwidth=1) + facet_grid(. ~ title) + ylim(0,1/3) +
        theme(strip.text.x = element_text(size = 22),
              # axis.title.y=element_text(size=22), axis.text.y=element_text(size=18),
              axis.title.y=element_blank(), axis.text.y=element_blank(), axis.ticks.y=element_blank(),
              axis.title.x=element_text(size=22), axis.text.x=element_text(size=18)
              )
    ggsave (filename, device="pdf")
#  par(oma=c(2,2,2,2))
#    dev.off()

}
