cat ("My pid:", Sys.getpid (), "\n\n")

AnzSubj <- 32
AnzTreat <- 10
AnzDat <- rep (AnzSubj, AnzTreat)

RefData <- read.table (file="pg-dat.csv", header=T, sep=",")
data <- RefData[,2:(AnzTreat+1)]

GroupSize <- c(2,2,2,2,2,4,4,4,4,4)
IntRet <- c(.02,.04,.04,.04,.04,.02,.02,.04,.04,.04)
ExtRet <- c(.06,.02,.04,.06,.12,.02,.06,.02,.04,.06)
TRatio <- c("1:3", "2:1", "1:1", "2:3", "1:3", "1:1", "1:3", "2:1", "1:1", "2:3")

filename <- ""
filename <- "hist-pg.pdf"

if (filename != "") pdf (filename, width=9, height=13)
  
layout (rbind(c(1,2),c(3,4),c(5,6),c(7,8),c(9,10)))

for (t in 1:AnzTreat) {
  up <- 25
  dons <- data[,t]
  title <- paste("Treatment", t,
                 paste("(", TRatio[t], ", m=", round(mean(dons), digits=1),
                       ", s=", round(sd(dons), digits=1), ")", sep=""))
  hist(dons,
       xlim=c(0,up), ylim=c(0,19),
       breaks=0:round(up/5)*5,
       main=list(title, cex=2),
       xlab=list("Donation", cex=1.6),
       ylab=list("Frequency", cex=1.6),
       cex.axis=1.6)
}

if (filename != "") dev.off()

#######################################################

LL <- 0
AnzSubj <- dim(data)[1]
for (t in 1:AnzTreat)
  for (s in 1:AnzSubj) {
    LL <- LL + log (sum(data[,t]==data[s,t])/AnzSubj)
  }

cat ("LL =", round (LL, digits=2), "\n")
 # LL = -787.42 

########################################################

LL2 <- 0
AnzSubj <- dim(data)[1]
for (t in 8:10)
  for (s in 1:AnzSubj) {
    LL2 <- LL2 + log (sum(data[,t]==data[s,t])/AnzSubj)
  }

cat ("LL2 =", round (LL2, digits=2), "\n")
 # LL2 = -233.67 



