cat ("My pid:", Sys.getpid (), "\n\n")

AnzSubj <- 32
AnzTreat <- 10
AnzDat <- rep (AnzSubj, AnzTreat)

RefData <- read.table (file="pg-dat.csv", header=T, sep=",")
data <- RefData[,2:(AnzTreat+1)]

GroupSize <- c(2,2,2,2,2,4,4,4,4,4)
IntRet <- c(.02,.04,.04,.04,.04,.02,.02,.04,.04,.04)
ExtRet <- c(.06,.02,.04,.06,.12,.02,.06,.02,.04,.06)
TRatio <- c("1:3", "2:1", "1:1", "2:3", "1:3", "1:1", "1:3", "2:1", "1:1", "2:3")


for (t in 1:AnzTreat) {
  up <- 25
  dons <- data[,t]
  
  filename <- paste("hist-pg2-", t, ".pdf", sep="")
  pdf (filename, width=9, height=6)
  par(mar=c(5,4.5,4,2) + 0.1)
  
#  title <- paste("Treatment", t, paste("(", TRatio[t], ", m=", round(mean(dons), digits=1), ", s=", round(sd(dons), digits=1), ")", sep=""))
  
  hist(dons/25,
       xlim=c(0,1), #ylim=c(0,120),
       breaks=0:100/100,
       main="",
#       main=list(paste("Treatment ", t, "  (B=", Up[t]/Step[t],", Tau1=", Step[t], ", ", expression(tau[2]), "=", Step[t]*Rate[t], ")", sep=""), cex=1.5),
       xlab=list("Budget share contributed", cex=1.8),
       ylab=list("Percentage of choices", cex=1.8),
       freq=FALSE,
       cex.axis=1.8)
  par(oma=c(2,2,2,2))
  dev.off()

#  hist(dons,
#       xlim=c(0,up), ylim=c(0,19),
#       breaks=0:round(up/5)*5,
#       main=list(title, cex=2),
#       xlab=list("Donation", cex=1.6),
#       ylab=list("Frequency", cex=1.6),
#       cex.axis=1.6)
}


#######################################################

LL <- 0
AnzSubj <- dim(data)[1]
for (t in 1:AnzTreat)
  for (s in 1:AnzSubj) {
    LL <- LL + log (sum(data[,t]==data[s,t])/AnzSubj)
  }

cat ("LL =", round (LL, digits=2), "\n")
 # LL = -787.42 

########################################################

LL2 <- 0
AnzSubj <- dim(data)[1]
for (t in 8:10)
  for (s in 1:AnzSubj) {
    LL2 <- LL2 + log (sum(data[,t]==data[s,t])/AnzSubj)
  }

cat ("LL2 =", round (LL2, digits=2), "\n")
 # LL2 = -233.67 



